Package: metapod
Version: 1.2.0
Date: 2021-05-12
Title: Meta-Analyses on P-Values of Differential Analyses
Authors@R: 
    person("Aaron", "Lun", role=c("aut", "cre"), email = "infinite.monkeys.with.keyboards@gmail.com")
Imports: Rcpp
Suggests: testthat, knitr, BiocStyle, rmarkdown
LinkingTo: Rcpp
biocViews: MultipleComparison, DifferentialPeakCalling
Description: 
    Implements a variety of methods for combining p-values in differential
    analyses of genome-scale datasets. Functions can combine p-values across
    different tests in the same analysis (e.g., genomic windows in ChIP-seq,
    exons in RNA-seq) or for corresponding tests across separate analyses
    (e.g., replicated comparisons, effect of different treatment conditions).
    Support is provided for handling log-transformed input p-values, missing
    values and weighting where appropriate. 
License: GPL-3
NeedsCompilation: yes
SystemRequirements: C++11
VignetteBuilder: knitr
RoxygenNote: 7.1.1
git_url: https://git.bioconductor.org/packages/metapod
git_branch: RELEASE_3_14
git_last_commit: 0da37b6
git_last_commit_date: 2021-10-26
Date/Publication: 2021-10-26
Packaged: 2021-10-26 21:51:07 UTC; biocbuild
Author: Aaron Lun [aut, cre]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

# Meta-analyses on p-values of differential analyses

|Build|Status|
|-----|----|
| [Bioc-release](https://bioconductor.org/packages/release/bioc/html/metapod.html) | [![](https://bioconductor.org/shields/build/release/bioc/metapod.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/metapod) |
| [Bioc-devel](https://bioconductor.org/packages/devel/bioc/html/metapod.html) | [![](https://bioconductor.org/shields/build/devel/bioc/metapod.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/metapod) | 

This package implements a variety of methods for combining p-values in differential analyses of genome-scale datasets.
It was initially designed for meta-analysis of differentially binding statistics in ChIP-seq,
but can be applied to any situation with many grouped or parallel sets of p-values.
Check out the user's guide on the [Bioconductor landing page](https://bioconductor.org/packages/devel/bioc/html/metapod.html) for more details.

NAME
    MetaPOD - An evolution of POD

VERSION
    version 0.3.0

What is MetaPOD
  1. Documentation About Documentation
    MetaPOD is a system intended to express the relationships between
    different documents, and express the importance and context of other
    things within the documents, and express how the documents as a whole
    fit together

  2. Documentation about Meta
    MetaPOD also is a system by which one can express relationships about
    code, code which has documentation, but how the documentation is related
    to other documentation requires you to normally understand the
    meta-level information within the code works, so, this system aims to
    make the "meta level" more visible from the surface, so the meta-level
    information can be more easily used to

    *   Aggregate multiple documents to a single document in line with how
        the Meta layer works

    *   Show pretty graphs and things showing how classes are related to
        each other

What can MetaPOD do for me
    At present, there is not much built on top of the MetaPOD "API", so it
    is marginally limited.

    And at present, there is not much on "CPAN" with MetaPOD annotations, so
    any such functionality is presently limited by that.

    However, for a taste of what we might see with widespread use of
    MetaPOD, here is what we can easily determine from the present "API",
    with the existing annotations in within MetaPOD itself:
    http://kentfredric.github.io/MetaPOD/media/self_structure.png

People who are writing MetaPOD
    Eventually, the goal is to have the MetaPOD itself able to be generated
    via tools during development, so that the meta-layer information is
    cemented into the POD itself, before, or during release.

    In that vein, I hope to make a "Dist::Zilla" plug-in that does this for
    you.

    In the mean time, the documents you want to be reading are

    *   "MetaPOD::Spec" - The general specification for all forms of MetaPOD

    *   "MetaPOD::JSON" - Information specific to the "JSON" based
        implementation of MetaPOD

People who are wanting to read MetaPOD
    *   "MetaPOD::Assembler" - The tool that translates documents containing
        "MetaPOD" into "MetaPOD::Result" Objects

AUTHOR
    Kent Fredric <kentfredric@gmail.com>

COPYRIGHT AND LICENSE
    This software is copyright (c) 2013 by Kent Fredric
    <kentfredric@gmail.com>.

    This is free software; you can redistribute it and/or modify it under
    the same terms as the Perl 5 programming language system itself.

#' Combine grouped p-values with Simes' method
#'
#' Combine p-values from grouped tests with Simes' method.
#' Groups are defined according to unique levels of a grouping factor.
#'
#' @param p.values A numeric vector containing p-values for individual tests.
#' @param grouping A vector or factor of length equal to \code{p.values}, specifying the group to which each test is assigned.
#'
#' Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{p.values} belonging to that group.
#' This assumes that \code{p.values} is ordered such that all entries in the same group are adjacent to each other.
#' @param weights A numeric vector of length equal to \code{p.values}, containing a positive weight for each test.
#' Alternatively \code{NULL}, in which case equal weights are assigned to all tests.
#' @param log.p Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.
#'
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a named numeric vector of length equal to the number of unique levels in \code{grouping}.
#' This contains the combined Simes p-value for each group, log-transformed if \code{log.p=TRUE}.
#' Each entry is named according to the group.
#' \item \code{representative}, a named integer scalar specifying the index of representative test for each group.
#' Each index refers to an entry of \code{p.values} and is named according to its group.
#' \item \code{influential}, a logical vector of length equal to \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value for its group.
#' }
#'
#' @inherit parallelSimes details
#' @inherit parallelSimes references
#' 
#' @author Aaron Lun
#' @examples
#' p1 <- rbeta(100, 0.8, 1)
#' g <- sample(10, length(p1), replace=TRUE)
#'
#' # Standard application:
#' out <- groupedSimes(p1, g)
#' str(out)
#'
#' # With weights:
#' out <- groupedSimes(p1, g, weights=rexp(length(p1)))
#' str(out)
#' 
#' # With log p-values. 
#' out <- groupedSimes(log(p1), g, log.p=TRUE)
#' str(out)
#'
#' @seealso
#' \code{\link{parallelSimes}}, for a version that operates on parallel vectors of p-values.
#'
#' @export
groupedSimes <- function(p.values, grouping, weights=NULL, log.p=FALSE) { 
    .grouped_compute(p.values, grouping, weights, log.p=log.p, FUN=compute_grouped_simes)
}

#' Combine parallel p-values with Simes' method
#'
#' Combine p-values from parallel tests with Simes' method.
#' Each group of p-values is defined from the corresponding entries across all vectors.
#'
#' @param p.values A list of numeric vectors of the same length, containing the p-values to be combined.
#' @param weights A numeric vector of positive weights, with one value per vector in \code{...}.
#' Each weight is applied to all entries of itscorresponding vector, i.e., all p-values in that vector receive the same weight.
#'
#' Alternatively, a list of numeric vectors of weights with the same structure as \code{p.values}.
#' Each p-value is then assigned the weight in the corresponding entry of \code{weights}.
#'
#' Alternatively \code{NULL}, in which case all p-values are assigned equal weight.
#' @param log.p Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.
#'
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
#' This contains the combined Simes p-value for each group, log-transformed if \code{log.p=TRUE}.
#' \item \code{representative}, an integer scalar specifying the representative test in each group.
#' Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
#' \item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
#' }
#' 
#' @details
#' The joint null hypothesis for each group is that all of the individual null hypotheses are true.
#' Simes' method will reject the joint null if any of the individual nulls are rejected, providing weak control of the family-wise error rate.
#' 
#' In theory, the method is only applicable to independent tests, but experience suggests that it is quite robust to dependencies.
#' The calculation itself is very closely related to the Benjamini-Hochberg method for controlling the false discovery rate.
#' One can actually obtain Simes' combined p-value by taking the smallest BH-adjusted p-value across a group.
#'
#' If non-equal weights are provided, they are treated as relative frequency weights.
#' That is, if one p-value is given a weight of 10 and another p-value is given a weight of 1, 
#' the former is considered to occur 10 times more frequently than the latter.
#'
#' The representative test for each group is defined as the test with the p-value that is ultimately used as the combined p-value.
#' Briefly, one can identify this test as that with the smallest BH-adjusted p-value if the monotonicity adjustment were omitted.
#' The influential tests for each group are defined as those with p-values no greater than the representative test's p-value.
#' This is based on the fact that increasing them (e.g., by setting them to unity) would result in a larger combined p-value.
#' 
#' @author Aaron Lun
#' @examples
#' p1 <- rbeta(100, 0.8, 1)
#' p2 <- runif(100)
#' p3 <- rbeta(100, 0.5, 1)
#'
#' # Standard application:
#' out <- parallelSimes(list(p1, p2, p3))
#' str(out)
#'
#' # With vector-level weights:
#' out <- parallelSimes(list(p1, p2, p3), weights=c(10, 20, 30))
#' str(out)
#' 
#' # With log p-values. 
#' out <- parallelSimes(list(log(p1), log(p2), log(p3)), log.p=TRUE)
#' str(out)
#'
#' @references
#' Simes RJ (1986).
#' An improved Bonferroni procedure for multiple tests of significance.
#' \emph{Biometrika} 73:751-754.
#'
#' Sarkar SK and Chung CK (1997).
#' The Simes method for multiple hypothesis testing with positively dependent test statistics.
#' \emph{J. Am. Stat. Assoc.} 92, 1601-1608.
#' 
#' Benjamini Y and Hochberg Y (1997).
#' Multiple hypotheses testing with weights.
#' \emph{Scand. J. Stat.} 24, 407-418.
#'
#' @seealso
#' \code{\link{groupedSimes}}, for a version that combines p-values based on a grouping factor.
#' @export
parallelSimes <- function(p.values, weights=NULL, log.p=FALSE) {
    .valid_logp(log.p)
    .valid_parallel_pvalues(p.values)
    .valid_parallel_weights(weights)

    compute_parallel_simes(p.values, weights, log.p)
}

# This tests the Simes-related functions.
# library(metapod); library(testthat); source("setup.R"); source("test-simes.R")

set.seed(20000)
p1 <- runif(1000)
p2 <- runif(1000)
p3 <- runif(1000)    

test_that("parallelSimes works correctly", {
    pout <- parallelSimes(list(p1, p2, p3))
    expect_equal(pout$p.value, apply(cbind(p1, p2, p3), 1, FUN=function(p) { min(p.adjust(p, method="BH")) })) 
    parallelTester(p1, p2, p3, FUN=parallelSimes)

    # Handles ties correctly.
    pout <- parallelSimes(list(p1, p2, p1))
    expect_equal(pout$p.value, apply(cbind(p1, p2, p1), 1, FUN=function(p) { min(p.adjust(p, method="BH")) })) 

    pout <- parallelSimes(list(p1, p1, p1))
    expect_equal(pout$p.value, p1)

    # Works correctly with weights.
    pout <- parallelSimes(list(p1, p2, p3), c(3,1,2))
    ref <- parallelSimes(rep(list(p1, p2, p3), c(3,1,2)))
    expect_identical(pout$p.value, ref$p.value)
    parallelTesterWithWeights(p1, p2, p3, FUN=parallelSimes)

    # Behaves sensibly at edge cases.
    expect_equal(parallelSimes(list(0, 0))$p.value, 0)
    expect_equal(parallelSimes(list(0, 1))$p.value, 0)
    expect_equal(parallelSimes(list(1, 1))$p.value, 1)
})

test_that("groupedSimes works correctly", {
    g <- sample(100, length(p1), replace=TRUE)
    groupedTester(p1, g, pFUN=parallelSimes, gFUN=groupedSimes)
    groupedTesterWithWeights(p1, g,  pFUN=parallelSimes, gFUN=groupedSimes)
})

#' Average grouped statistics 
#'
#' Average grouped statistics with consideration of weights and protection from missing values.
#' 
#' @param values A numeric vector containing statistics for individual tests.
#' @inheritParams groupedSimes
#'
#' @details
#' If \code{weights} is supplied, a weighted average is computed for each group.
#' If \code{values} contains missing values, they are ignored and will not contribute to the average.
#'
#' @return A named numeric vector of (weighted) averages, of length equal to the number of unique levels in \code{grouping}.
#'
#' @author Aaron Lun
#' 
#' @examples
#' grouping <- sample(LETTERS, 20, replace=TRUE)
#' averageGroupedStats(1:20, grouping)
#' averageGroupedStats(1:20, grouping, weights=runif(20))
#'
#' @seealso
#' \code{\link{averageParallelStats}}, for the parallel counterpart.
#'
#' @export
averageGroupedStats <- function(values, grouping, weights=NULL) {
    grouped <- .prepare_grouped_inputs(grouping, list(values=values, weights=weights))
    RLE <- grouped$runs
    values <- grouped$x$values
    weights <- grouped$x$weights

    last <- 0L
    collated <- numeric(length(RLE$value))
    for (i in seq_along(collated)) {
        run.len <- RLE$length[i]

        chosen <- last + seq_len(run.len)
        curvals <- values[chosen]
        keep <- !is.na(curvals)
        curvals <- curvals[keep]

        if (!is.null(weights)) {
            curw <- weights[chosen[keep]]
            if (!all(curw > 0)) {
                stop("'weights' must be all positive")
            }
            meanval <- sum(curvals * curw)/sum(curw)
        } else {
            meanval <- mean(curvals)
        }

        collated[i] <- meanval
        last <- last + run.len
    }

    names(collated) <- RLE$value
    collated
}

# This tests the averaging functions.
# library(testthat); library(metapod); source("test-average.R")

test_that("parallel averaging works as expected", {
    p <- list(rnorm(10), rnorm(10))
    out <- averageParallelStats(p)
    expect_equal(out, (p[[1]] + p[[2]])/2)

    # Works for different weight settings.
    p <- list(rnorm(10), rnorm(10))
    out <- averageParallelStats(p, weights=1:2)
    expect_equal(out, (p[[1]] + p[[2]]*2)/3)

    # Works for list weights.
    p <- list(rnorm(10), rnorm(10))
    w <- list(runif(10), runif(10))
    out <- averageParallelStats(p, weights=w)
    expect_equal(out, (p[[1]] * w[[1]] + p[[2]] * w[[2]])/(w[[1]] + w[[2]]))

    # Handles missing values appropriately.
    p <- list(rnorm(10), rnorm(10))
    p[[1]][c(1, 3)] <- NA
    p[[2]][c(2, 3)] <- NA

    out <- averageParallelStats(p)
    expect_equal(out[1], p[[2]][1])
    expect_equal(out[2], p[[1]][2])
    expect_true(is.na(out[3]))
    expect_identical(out[-(1:3)], averageParallelStats(lapply(p, tail, -3)))

    p <- list(rnorm(10), rnorm(10), rnorm(10))
    p[[1]][c(1, 3)] <- NA
    p[[2]][c(2, 3)] <- NA
    w <- list(runif(10), runif(10), runif(10))

    out <- averageParallelStats(p, weights=w)
    expect_equal(out[1], averageParallelStats(p[-1], w[-1])[1])
    expect_equal(out[2], averageParallelStats(p[-2], w[-2])[2])
    expect_equal(out[3], p[[3]][3])
    expect_equal(out[-(1:3)], (Reduce("+", mapply("*", p, w, SIMPLIFY=FALSE))/Reduce("+", w))[-(1:3)])

    # Handles errors properly.
    expect_error(averageParallelStats(list(rnorm(10), 1)), "same length")
    p <- list(rnorm(10), rnorm(10))
    expect_error(averageParallelStats(p, weights=c(-1, 0)), "must be positive")
    expect_error(averageParallelStats(p, weights=1), "not TRUE")
    expect_error(averageParallelStats(p, weights=list(1,1)), "same 'lengths'")
})

test_that("groupe averaging works as expected", {
    p <- rnorm(100)
    g <- sample(LETTERS, length(p), replace=TRUE)

    out <- averageGroupedStats(p, g)
    expect_equal(out, vapply(split(p, g), mean, 0))

    # Handles weighting.
    w <- runif(100)
    out <- averageGroupedStats(p, g, weights=w)
    by.group <- split(seq_along(g), g)
    expect_equal(out, vapply(by.group, function(i) weighted.mean(p[i], w[i]), 0))

    # Handles missing values.
    thrown <- sample(length(p), length(p)/2)
    p2 <- p
    p2[-thrown] <- NA_real_

    out <- averageGroupedStats(p2, g) 
    expect_identical(names(out), sort(unique(g)))

    ref <- averageGroupedStats(p2[thrown], g[thrown])
    common <- names(ref)
    expect_identical(out[common], ref[common])
    expect_true(all(is.na(out[setdiff(names(out), names(ref))])))

    # Missing values and weights interact properly.
    out <- averageGroupedStats(p2, g, weights=w) 
    ref <- averageGroupedStats(p2[thrown], g[thrown], weights=w[thrown])
    common <- names(ref)
    expect_identical(out[common], ref[common])
    expect_true(all(is.na(out[setdiff(names(out), names(ref))])))
})

#' Combine parallel p-values with the minimum Holm approach
#'
#' Combine p-values from parallel tests with the minimum Holm approach.
#' Each group of p-values is defined from the corresponding entries across all vectors.
#'
#' @inheritParams parallelSimes
#' @param min.n Integer scalar specifying the minimum number of individual nulls to reject when testing the joint null.
#' @param min.prop Numeric scalar in [0, 1], specifying the minimum proportion of individual nulls to reject when testing the joint null.
#'
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
#' This contains the combined p-value for each group, log-transformed if \code{log.p=TRUE}.
#' \item \code{representative}, an integer scalar specifying the representative test in each group.
#' Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
#' \item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final per-group p-value.
#' }
#'
#' @details
#' Here, the joint null hypothesis for each group is that fewer than \eqn{N} individual null hypotheses are false.
#' The joint null is only rejected if \eqn{N} or more individual nulls are rejected; hence the \dQuote{minimum} in the function name.
#'
#' \eqn{N} is defined as the larger of \code{min.n} and the product of \code{min.prop} with the number of tests in the group (rounded up).
#' This allows users to scale rejection of the joint null with the size of the group, while avoiding a too-low \eqn{N} when the group is small.
#' Note that \eqn{N} is always capped at the total size of the group.
#'
#' To compute the combined p-value, we apply the Holm-Bonferroni correction to all p-values in the set and take the \eqn{N}-th smallest value.
#' This effectively recapitulates the step-down procedure where we reject individual nulls until we reach the \eqn{N}-th test.
#' This method works correctly in the presence of dependencies between p-values.
#' 
#' If non-equal weights are provided, they are used to effectively downscale the p-values. 
#' This aims to redistribute the error rate across the individual tests,
#' i.e., tests with lower weights are given fewer opportunities to drive acceptance of the joint null.
#'
#' The representative test for each group is defined as that with the \eqn{N}-th smallest p-value, as this is directly used as the combined p-value.
#' The influential tests for each group are defined as those with p-values no greater than the representative test's p-value.
#' This is based on the fact that increasing them (e.g., by setting them to unity) would result in a larger combined p-value.
#' 
#' @author Aaron Lun
#' @examples
#' p1 <- rbeta(100, 0.8, 1)
#' p2 <- runif(100)
#' p3 <- rbeta(100, 0.5, 1)
#'
#' # Standard application:
#' out <- parallelHolmMin(list(p1, p2, p3))
#' str(out)
#'
#' # With vector-level weights:
#' out <- parallelHolmMin(list(p1, p2, p3), weights=c(10, 20, 30))
#' str(out)
#' 
#' # With log p-values. 
#' out <- parallelHolmMin(list(log(p1), log(p2), log(p3)), log.p=TRUE)
#' str(out)
#'
#' @references
#' Holm S (1979).
#' A simple sequentially rejective multiple test procedure.
#' \emph{Scand. J. Stat.} 6, 65-70.
#'
#' @seealso
#' \code{\link{groupedHolmMin}}, for a version that combines p-values based on a grouping factor.
#'
#' \code{\link{parallelWilkinson}}, for a more relaxed version of this test when hypotheses are independent.
#'
#' @export
parallelHolmMin <- function(p.values, weights=NULL, log.p=FALSE, min.n=1, min.prop=0.5) {
    .valid_logp(log.p)
    .valid_parallel_pvalues(p.values)
    .valid_min_vals(min.n, min.prop)

    compute_parallel_holm_min(p.values, weights, log.p, min.n, min.prop)
}

# This tests the Holm-related functions.
# library(metapod); library(testthat); source("setup.R"); source("test-holm-min.R")

set.seed(20000)
p1 <- runif(1000)
p2 <- runif(1000)
p3 <- runif(1000)    

test_that("parallelHolmMin method works correctly", {
    parallelTester(p1, p2, p3, FUN=parallelHolmMin)

    # Testing alternative min.num, min.prop settings.
    p4 <- runif(1000)    
    together <- cbind(p1, p2, p3, p4)

    for (i in seq_len(4)) {
        pout <- parallelHolmMin(list(p1, p2, p3, p4), min.n=i, min.prop=0)
        expect_equal(pout$p.value, apply(together, 1, FUN=function(p) { sort(p.adjust(p, method="holm"))[i] })) 
        expect_equal(pout$representative, apply(together, 1, FUN=function(p) { order(p)[i] })) 
        expect_equal(do.call(rbind, pout$influential), apply(together, 1, FUN=function(p) { 1:4 %in% order(p)[1:i] })) 
    }

    for (p in c(0.2, 0.25, 0.45, 0.65, 0.75, 0.85)) {
        pout <- parallelHolmMin(list(p1, p2, p3, p4), min.prop=p)
        N <- max(ceiling(p * ncol(together)), 1)
        expect_equal(pout$p.value, apply(together, 1, FUN=function(p) { sort(p.adjust(p, method="holm"))[N] })) 
        expect_equal(pout$representative, apply(together, 1, FUN=function(p) { order(p)[N] })) 
        expect_equal(do.call(rbind, pout$influential), apply(together, 1, FUN=function(p) { 1:4 %in% order(p)[1:N] })) 
    }

    # Handles ties correctly.
    pout <- parallelHolmMin(list(p1, p2, p1))
    expect_equal(pout$p.value, apply(cbind(p1, p2, p1), 1, FUN=function(p) { median(p.adjust(p, method="holm")) })) 

    pout <- parallelHolmMin(list(p1, p1, p1))
    expect_equal(pout$p.value, apply(cbind(p1, p1, p1), 1, FUN=function(p) { median(p.adjust(p, method="holm")) })) 

    # Behaves as a special case of lowest-Bonferroni.
    pout <- parallelHolmMin(list(p1, p2, p3), min.prop=0)
    expect_equal(pout$p.value, pmin(p1, p2, p3, 1/3)*3)

    # Handles weights correctly.
    parallelTesterWithWeights(p1, p2, p3, FUN=parallelHolmMin)

    for (i in seq_len(4)) {
        w <- runif(4)
        pout <- parallelHolmMin(list(p1, p2, p3, p4), min.n=i, min.prop=0, weights=w)
        expect_equal(pout$p.value, apply(together, 1, FUN=function(p) { 
            p <- p/w
            o <- order(p)
            wx <- sum(w) - c(0, head(cumsum(w[o]), -1))
            out <- cummax(p[o] * wx)[i]
            min(out, 1)
        }))
        expect_equal(pout$representative, apply(together, 1, FUN=function(p) { order(p/w)[i] })) 
        expect_equal(do.call(rbind, pout$influential), apply(together, 1, FUN=function(p) { 1:4 %in% order(p/w)[1:i] })) 
    }

    # Behaves sensibly at edge cases.
    expect_equal(parallelHolmMin(list(0, 0))$p.value, 0)
    expect_equal(parallelHolmMin(list(0, 1))$p.value, 0)
    expect_equal(parallelHolmMin(list(1, 1))$p.value, 1)
})

test_that("groupedHolmMin works correctly", {
    g <- sample(100, length(p1), replace=TRUE)
    groupedTester(p1, g, pFUN=parallelHolmMin, gFUN=groupedHolmMin)
    groupedTesterWithWeights(p1, g,  pFUN=parallelHolmMin, gFUN=groupedHolmMin)
})

#' Summarize overall direction of grouped tests
#'
#' Summarize the overall direction of grouped tests in a meta-analysis,
#' based on the influential tests defined by one of the \code{grouped*} functions.
#'
#' @param effects A numeric vector containing the effect size for each test.
#' @param grouping A vector of factor of length equal to \code{effects}, specifying the assigned group for each tests.
#'
#' Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{effects} belonging to that group.
#' This assumes that \code{effects} is ordered such that all entries in the same group are adjacent to each other.
#' @param influential A logical vector of length equal to \code{effects},
#' indicating whether each test is influential in its assigned group.
#' @inheritParams summarizeParallelDirection
#'
#' @inherit summarizeParallelDirection return
#' @inherit summarizeParallelDirection details
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{groupedSimes}} and related \code{grouped*} functions, to obtain \code{influential}.
#'
#' \code{\link{summarizeParallelDirection}}, for the equivalent function based on parallel tests.
#'
#' \code{\link{countGroupedDirection}}, to count the number of effects in each direction.
#' @examples
#' p <- rbeta(100, 0.5, 1)
#' eff <- rnorm(100)
#' g <- sample(20, 100, replace=TRUE)
#'
#' out <- groupedSimes(p, g)
#' (dir <- summarizeGroupedDirection(eff, g, out$influential))
#' @export
summarizeGroupedDirection <- function(effects, grouping, influential, threshold=0) {
    stopifnot(is.numeric(effects))
    stopifnot(is.logical(influential))
    .valid_summary_threshold(threshold)

    gout <- .prepare_grouped_inputs(grouping, list(effects=effects, influential=influential))
    effects <- gout$x[[1]]
    influential <- gout$x[[2]]
    runs <- gout$runs

    output <- summarize_grouped_direction(effects, runs$lengths, influential, threshold) 
    output <- c("none", "down", "up", "mixed")[output]
    names(output) <- runs$values
    output
}

# This tests the summarization of the direction.
# library(testthat); library(metapod); source("test-summarize.R")

test_that("summarizeParallelDirection works as expected", {
    influential <- list(
        rbinom(100, 1, 0.5) > 0,
        rbinom(100, 1, 0.5) > 0,
        rbinom(100, 1, 0.5) > 0
    )

    effects <- list(
        rnorm(100),
        rnorm(100),
        rnorm(100)
    )

    out <- summarizeParallelDirection(effects, influential)

    all.I <- do.call(cbind, influential)
    all.E <- do.call(cbind, effects)

    up.E <- rowSums(all.I * (all.E > 0))
    down.E <- rowSums(all.I * (all.E < 0))

    ref <- c("none", "down", "up", "mixed")[1 + (down.E > 0) + (up.E > 0)*2]
    expect_identical(ref, out)

    # Works with edge cases.
    expect_identical(
        summarizeParallelDirection(effects[0], influential[0]),
        character(0)
    )

    # Handles error states.
    expect_error(summarizeParallelDirection(effects, influential[1]), "same structure")
    expect_error(summarizeParallelDirection(effects, lapply(influential, head)), "same structure")
})

test_that("summarizeGroupedDirection works as expected", {
    influential <- rbinom(100, 1, 0.5) > 0
    effects <- rnorm(100)
    g <- sample(50, 100, replace=TRUE)
    out <- summarizeGroupedDirection(effects, grouping=g, influential=influential)

    # Comparing to the parallel method.
    by.g <- split(seq_along(g), g)
    for (x in names(by.g)) {
        current <- by.g[[x]]
        by.g[[x]] <- summarizeParallelDirection(as.list(effects[current]), influential=as.list(influential[current]))
    }

    expect_identical(unlist(by.g), out)

    # Handles error states. 
    expect_error(summarizeGroupedDirection(effects, rle(g[1:10]), influential), "runs.*not the same")
    expect_error(summarizeGroupedDirection(effects[1:10], rle(g), influential[1:10]), "runs.*not the same")
    expect_error(summarizeGroupedDirection(effects[1:10], g[1:10], influential), "not the same")
    expect_error(summarizeGroupedDirection(effects, g, influential[1:10]), "not the same")
})

#' Combine parallel p-values
#'
#' Combine p-values from parallel hypothesis tests using a variety of meta-analysis methods.
#' Each group of p-values is defined from the corresponding entries across all vectors.
#' The function processes all vectors \dQuote{in parallel} - hence the name.
#' 
#' @inheritParams parallelHolmMin
#' @param method String specifying the method to use to combine p-values.
#' 
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
#' This contains the Simes p-value for each group, log-transformed if \code{log.p=TRUE}.
#' \item \code{representative}, an integer scalar specifying the representative test in each group.
#' Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
#' \item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
#' }
#'
#' @details
#' \code{min.prop} and \code{min.n} only have an effect for \code{method="wilkinson"} and \code{"holm-min"}.
#'
#' \code{weights} only has an effect for \code{method="simes"}, \code{"holm-min"} and \code{"stouffer"}.
#' 
#' @author
#' Aaron Lun
#' 
#' @examples
#' p1 <- runif(10000)
#' p2 <- runif(10000)
#' p3 <- runif(10000)
#' 
#' fish <- combineParallelPValues(list(p1, p2, p3), method="fisher")
#' hist(fish$p.value)
#' 
#' z <- combineParallelPValues(list(p1, p2, p3), method="stouffer", weights=1:3)
#' hist(z$p.value)
#' 
#' simes <- combineParallelPValues(list(p1, p2, p3), method="simes")
#' hist(simes$p.value)
#' 
#' berger <- combineParallelPValues(list(p1, p2, p3), method="berger")
#' hist(berger$p.value)
#'
#' @export
combineParallelPValues <- function(p.values,
    method=c("simes", "holm-min", "berger", "fisher", "pearson", "wilkinson", "stouffer"),
    weights=NULL, log.p=FALSE, min.n=1, min.prop=0.5) 
{
    method <- match.arg(method)
    all.args <- list(p.values=p.values, weights=weights, log.p=log.p, min.n=min.n, min.prop=min.prop) 

    FUN <- switch(method,
        simes=parallelSimes,
        `holm-min`=parallelHolmMin,
        berger=parallelBerger,
        fisher=parallelFisher,
        pearson=parallelPearson,
        wilkinson=parallelWilkinson,
        stouffer=parallelStouffer
    )

    keep <- names(formals(FUN))
    do.call(FUN, all.args[keep])
}

#' Summarize overall direction of parallel tests
#'
#' Summarize the overall direction of parallel tests in a meta-analysis,
#' based on the influential tests defined by one of the \code{parallel*} functions.
#'
#' @param effects A list of numeric vectors of the same length, containing the effect sizes for each set of tests.
#' Each group of tests is defined as corresponding entries across vectors.
#' @param influential A list of logical vectors with the same structure as \code{effects},
#' specifying the tests that are influential to the final per-group p-value.
#' @param threshold Numeric scalar defining the threshold at which an effect is \dQuote{"up"} or \dQuote{"down"}.
#'
#' @return A character vector of length equal to the number of groups.
#' Each entry can be:
#' \itemize{
#' \item \code{"up"}, if all influential tests have effects above \code{threshold}.
#' \item \code{"down"}, if all influential tests have effects below \code{threshold}.
#' \item \code{"none"}, if all influential tests have effects equal to \code{threshold}.
#' \item \code{"mixed"}, if there are influential tests with effects above and below \code{threshold}.
#' }
#'
#' @details
#' We focus on the direction of effect for the influential tests that actually contribute to a group's final p-value.
#' For example, if we did our meta-analysis using \code{\link{parallelSimes}},we are not particularly concerned about the direction of tests with large p-values.
#' Thus, we just ignore them when summarizing the group's direction in this function.
#' Otherwise, we would unnecessarily obtain a \code{mixed} direction of effect if a test with a large p-value had a weakly opposing effect.
#'
#' Of course, the interpretation of \dQuote{influential} really depends on the choice of meta-analysis strategy.
#' It is also possible that this function reports a single direction when the group really is mixed,
#' e.g., if the tests with the lowest p-values are changing in one direction but tests with weaker but still interesting effects are changing in the other direction.
#' The extent to which this is of interest is left to the discretion of the user. 
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{parallelSimes}} and related \code{parallel*} functions, to obtain \code{influential}.
#'
#' \code{\link{summarizeGroupedDirection}}, for the equivalent function based on a grouping factor.
#'
#' \code{\link{countParallelDirection}}, to count the number of effects in each direction.
#'
#' @examples
#' p1 <- rbeta(100, 0.5, 1)
#' eff1 <- rnorm(100)
#' p2 <- rbeta(100, 0.5, 1)
#' eff2 <- rnorm(100)
#'
#' out <- parallelSimes(list(p1, p2))
#' (dir <- summarizeParallelDirection(list(eff1, eff2), out$influential))
#'
#' @export
summarizeParallelDirection <- function(effects, influential, threshold=0) {
    .valid_parallel_effects(effects)
    .valid_parallel_influential(influential)
    .valid_summary_threshold(threshold)

    i <- summarize_parallel_direction(effects, influential, threshold)
    c("none", "down", "up", "mixed")[i]
}

# Note that the repeated definitions are very intentional here; it ensures that
# errors are presented with the correct argument name.

.valid_logp <- function(log.p) {
    stopifnot(isTRUE(log.p) || isFALSE(log.p))
}

.valid_parallel_pvalues <- function(p.values) {
    stopifnot(is.list(p.values), all(vapply(p.values, is.numeric, TRUE)))
}

.valid_count_thresholds <- function(p.threshold, effect.threshold) {
    stopifnot(length(p.threshold)==1L, is.numeric(p.threshold), is.finite(p.threshold))
    stopifnot(length(effect.threshold)==1L, is.numeric(effect.threshold), is.finite(effect.threshold))
}

.valid_summary_threshold <- function(threshold) {
    stopifnot(length(threshold)==1L, is.numeric(threshold), is.finite(threshold))
}

.valid_min_vals <- function(min.n, min.prop) {
    stopifnot(length(min.n)==1L, is.numeric(min.n), is.finite(min.n))
    stopifnot(length(min.prop)==1L, is.numeric(min.prop), is.finite(min.prop))
}

.valid_parallel_effects <- function(effects) {
    stopifnot(is.list(effects), all(vapply(effects, is.numeric, TRUE)))
}

.valid_parallel_influential <- function(influential) {
    stopifnot(is.list(influential), all(vapply(influential, is.logical, TRUE)))
}

.valid_parallel_weights <- function(weights) {
    if (!is.null(weights)) {
        if (is.list(weights)) {
            stopifnot(all(vapply(weights, is.numeric, TRUE)))
        } else {
            stopifnot(is.numeric(weights))
        }
    }
}

#' Combine parallel p-values with Fisher's method
#'
#' Combine p-values from parallel tests with Fisher's method.
#' Each group of p-values is defined from the corresponding entries across all vectors.
#'
#' @inheritParams parallelSimes
#'
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
#' This contains the combined Fisher p-value for each group, log-transformed if \code{log.p=TRUE}.
#' \item \code{representative}, an integer scalar specifying the representative test in each group.
#' Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
#' \item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
#' }
#'
#' @details
#' The joint null hypothesis for each group is that all of the individual null hypotheses are true.
#' Fisher's method combines information from all individual nulls to determine if the joint null should be rejected.
#' Compared to Stouffer's and Pearson's methods, Fisher's method provides more sensitivity to the smallest individual p-value.
#' This method is only applicable to independent tests and no weights are considered.
#'
#' The representative test for each group is defined as the test with the lowest p-value, as this has the greatest effect on the combined p-value. 
#' All tests for each group are considered to be influential as increasing any of them (e.g., to unity) would result in a larger combined p-value.
#' 
#' @author Aaron Lun
#' @examples
#' p1 <- rbeta(100, 0.8, 1)
#' p2 <- runif(100)
#' p3 <- rbeta(100, 0.5, 1)
#'
#' # Standard application:
#' out <- parallelFisher(list(p1, p2, p3))
#' str(out)
#'
#' # With log p-values. 
#' out <- parallelFisher(list(log(p1), log(p2), log(p3)), log.p=TRUE)
#' str(out)
#'
#' @seealso
#' \code{\link{groupedFisher}}, for a version that combines p-values based on a grouping factor.
#'
#' \code{\link{parallelStouffer}} and \code{\link{parallelPearson}}, for different approaches to testing a joint null of independent hypotheses.
#'
#' @references
#' Fisher RA (1925).
#' \emph{Statistical Methods for Research Workers}.
#' Oliver and Boyd (Edinburgh).
#' @export
parallelFisher <- function(p.values, log.p=FALSE) {
    .valid_logp(log.p)
    .valid_parallel_pvalues(p.values)

    compute_parallel_fisher(p.values, NULL, log.p)
}

#' Combine p-values with Wilkinson's method
#'
#' Combine p-values from parallel tests with Wilkinson's method.
#' Each group of p-values is defined from the corresponding entries across all vectors.
#' The function processes all vectors \dQuote{in parallel} - hence the name.
#'
#' @inheritParams parallelHolmMin
#'
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
#' This contains the combined p-value for each group, log-transformed if \code{log.p=TRUE}.
#' \item \code{representative}, an integer scalar specifying the representative test in each group.
#' Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
#' \item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final per-group p-value.
#' }
#'
#' @details
#' Here, the joint null hypothesis for each group is all individual null hypotheses are false.
#' Rejection of the joint null is heavily favored in situations where \eqn{N} or more individual nulls are rejected.
#' This is achieved in Wilkinson's method by considering the \eqn{N}-th order statistic for uniformly distributed p-values.
#' The individual tests are assumed to be independent, and all weights are ignored.
#'
#' \eqn{N} is defined as the larger of \code{min.n} and the product of \code{min.prop} with the number of tests in the group (rounded up).
#' This allows users to scale rejection of the joint null with the size of the group, while avoiding a too-low \eqn{N} when the group is small.
#' Note that \eqn{N} is always capped at the total size of the group.
#'
#' The representative test for each group is defined as that with the \eqn{N}-th smallest p-value, as this is used to compute the combined p-value.
#' The influential tests for each group are defined as those with p-values no greater than the representative test's p-value.
#' This is based on the fact that increasing them (e.g., by setting them to unity) would result in a larger combined p-value.
#' 
#' @author Aaron Lun
#' @examples
#' p1 <- rbeta(100, 0.8, 1)
#' p2 <- runif(100)
#' p3 <- rbeta(100, 0.5, 1)
#'
#' # Standard application:
#' out <- parallelWilkinson(list(p1, p2, p3))
#' str(out)
#'
#' # With log p-values. 
#' out <- parallelWilkinson(list(log(p1), log(p2), log(p3)), log.p=TRUE)
#' str(out)
#'
#' @seealso
#' \code{\link{groupedWilkinson}}, for a version that combines p-values based on a grouping factor.
#'
#' \code{\link{parallelHolmMin}}, which has a more strict interpretation of \emph{N}, amongst other things.
#'
#' @references
#' Wilkinson B (1951).
#' A statistical consideration in psychological research.
#' \emph{Psychol. Bull.} 48, 156-158.
#'
#' @export
parallelWilkinson <- function(p.values, log.p=FALSE, min.n=1, min.prop=0.5) {
    .valid_logp(log.p)
    .valid_parallel_pvalues(p.values)
    .valid_min_vals(min.n, min.prop)

    compute_parallel_wilkinson(p.values, NULL, log.p, min.n, min.prop)
}

.prepare_grouped_inputs <- function(grouping, x) {
    if (inherits(grouping, "rle")) {
        o <- seq_len(sum(grouping$lengths))
        runs <- grouping
    } else {
        o <- order(grouping)
        if (is.factor(grouping)) {
            tab <- table(grouping) # this should respect the order.
            stopifnot(identical(levels(grouping), names(tab)))
            runs <- list(lengths=as.integer(tab), values=names(tab))
            class(runs) <- "rle"
        } else {
            runs <- rle(grouping[o])
        }

        for (i in seq_along(x)) {
            if (!is.null(x[[i]])) {
                if (length(x[[i]])!=length(grouping)) {
                    stop("lengths of 'grouping' and '", names(x)[i], "' are not the same")
                }
                x[[i]] <- x[[i]][o]
            }
        }
    }
    
    list(order=o, x=x, runs=runs)
}

.grouped_compute <- function(p.values, grouping, weights=NULL, ..., log.p, FUN) {
    .valid_logp(log.p)
    stopifnot(is.numeric(p.values))
    if (!is.null(weights)) {
        stopifnot(is.numeric(weights))
    }

    gout <- .prepare_grouped_inputs(grouping, list(p.values=p.values, weights=weights))
    o <- gout$order
    p.values <- gout$x[[1]]
    weights <- gout$x[[2]]
    runs <- gout$runs

    output <- FUN(p.values, runs$lengths, weights, ..., log=log.p)
    output$representative <- o[output$representative]
    output$influential[o] <- output$influential
    names(output$p.value) <- names(output$representative) <- as.character(runs$values)

    output
}

#' Combine grouped p-values
#'
#' Combine p-values from grouped hypothesis tests using a variety of meta-analysis methods.
#' Each group of p-values is defined as those assigned to the same level of the grouping factor.
#' 
#' @inheritParams groupedHolmMin
#' @param method String specifying the method to use to combine p-values.
#' 
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a named numeric vector of length equal to the number of unique levels in \code{grouping}.
#' This contains the combined p-value for each group, log-transformed if \code{log.p=TRUE}.
#' Each entry is named according to the group.
#' \item \code{representative}, a named integer scalar specifying the index of representative test for each group.
#' Each index refers to an entry of \code{p.values} and is named according to its group.
#' \item \code{influential}, a logical vector of length equal to \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value for its group.
#' }
#'
#' @inherit combineParallelPValues details
#' 
#' @author
#' Aaron Lun
#' 
#' @examples
#' p <- runif(10000)
#' g <- sample(100, 10000, replace=TRUE)
#'
#' fish <- combineGroupedPValues(p, g, method="fisher")
#' hist(fish$p.value)
#' 
#' z <- combineGroupedPValues(p, g, method="stouffer", weights=rexp(10000))
#' hist(z$p.value)
#' 
#' simes <- combineGroupedPValues(p, g, method="simes")
#' hist(simes$p.value)
#' 
#' berger <- combineGroupedPValues(p, g, method="berger")
#' hist(berger$p.value)
#'
#' @export
combineGroupedPValues <- function(p.values, grouping, 
    method=c("simes", "holm-min", "berger", "fisher", "pearson", "wilkinson", "stouffer"),
    weights=NULL, log.p=FALSE, min.n=1, min.prop=0.5)
{
    method <- match.arg(method)
    all.args <- list(p.values=p.values, grouping=grouping, weights=weights, log.p=log.p, min.n=min.n, min.prop=min.prop)

    FUN <- switch(method,
        simes=groupedSimes,
        `holm-min`=groupedHolmMin,
        berger=groupedBerger,
        fisher=groupedFisher,
        pearson=groupedPearson,
        wilkinson=groupedWilkinson,
        stouffer=groupedStouffer
    )

    keep <- names(formals(FUN))
    do.call(FUN, all.args[keep])
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

compute_grouped_simes <- function(pvals, runs, weights, log) {
    .Call('_metapod_compute_grouped_simes', PACKAGE = 'metapod', pvals, runs, weights, log)
}

compute_grouped_berger <- function(pvals, runs, weights, log) {
    .Call('_metapod_compute_grouped_berger', PACKAGE = 'metapod', pvals, runs, weights, log)
}

compute_grouped_wilkinson <- function(pvals, runs, weights, log, min_n, min_prop) {
    .Call('_metapod_compute_grouped_wilkinson', PACKAGE = 'metapod', pvals, runs, weights, log, min_n, min_prop)
}

compute_grouped_holm_min <- function(pvals, runs, weights, log, min_n, min_prop) {
    .Call('_metapod_compute_grouped_holm_min', PACKAGE = 'metapod', pvals, runs, weights, log, min_n, min_prop)
}

compute_grouped_stouffer <- function(pvals, runs, weights, log) {
    .Call('_metapod_compute_grouped_stouffer', PACKAGE = 'metapod', pvals, runs, weights, log)
}

compute_grouped_fisher <- function(pvals, runs, weights, log) {
    .Call('_metapod_compute_grouped_fisher', PACKAGE = 'metapod', pvals, runs, weights, log)
}

compute_grouped_pearson <- function(pvals, runs, weights, log) {
    .Call('_metapod_compute_grouped_pearson', PACKAGE = 'metapod', pvals, runs, weights, log)
}

compute_parallel_simes <- function(pvals, weights, log) {
    .Call('_metapod_compute_parallel_simes', PACKAGE = 'metapod', pvals, weights, log)
}

compute_parallel_berger <- function(pvals, weights, log) {
    .Call('_metapod_compute_parallel_berger', PACKAGE = 'metapod', pvals, weights, log)
}

compute_parallel_wilkinson <- function(pvals, weights, log, min_n, min_prop) {
    .Call('_metapod_compute_parallel_wilkinson', PACKAGE = 'metapod', pvals, weights, log, min_n, min_prop)
}

compute_parallel_holm_min <- function(pvals, weights, log, min_n, min_prop) {
    .Call('_metapod_compute_parallel_holm_min', PACKAGE = 'metapod', pvals, weights, log, min_n, min_prop)
}

compute_parallel_stouffer <- function(pvals, weights, log) {
    .Call('_metapod_compute_parallel_stouffer', PACKAGE = 'metapod', pvals, weights, log)
}

compute_parallel_fisher <- function(pvals, weights, log) {
    .Call('_metapod_compute_parallel_fisher', PACKAGE = 'metapod', pvals, weights, log)
}

compute_parallel_pearson <- function(pvals, weights, log) {
    .Call('_metapod_compute_parallel_pearson', PACKAGE = 'metapod', pvals, weights, log)
}

count_parallel_direction <- function(pvalues, effects, method, pthreshold, ethreshold, log) {
    .Call('_metapod_count_parallel_direction', PACKAGE = 'metapod', pvalues, effects, method, pthreshold, ethreshold, log)
}

count_grouped_direction <- function(pvalues, runs, effects, method, pthreshold, ethreshold, log) {
    .Call('_metapod_count_grouped_direction', PACKAGE = 'metapod', pvalues, runs, effects, method, pthreshold, ethreshold, log)
}

summarize_parallel_direction <- function(effects, influential, threshold) {
    .Call('_metapod_summarize_parallel_direction', PACKAGE = 'metapod', effects, influential, threshold)
}

summarize_grouped_direction <- function(effects, runs, influential, threshold) {
    .Call('_metapod_summarize_grouped_direction', PACKAGE = 'metapod', effects, runs, influential, threshold)
}

#' Combine grouped p-values with Stouffer's Z-score method
#'
#' Combine p-values from grouped tests with Stouffer's Z-score method.
#' Groups are defined according to unique levels of a grouping factor.
#'
#' @inheritParams groupedSimes
#'
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a named numeric vector of length equal to the number of unique levels in \code{grouping}.
#' This contains the combined p-value for each group, log-transformed if \code{log.p=TRUE}.
#' Each entry is named according to the group.
#' \item \code{representative}, a named integer scalar specifying the representative test for each group.
#' Each entry is named according to the group.
#' \item \code{influential}, a logical vector of length equal to \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value for its group.
#' }
#'
#' @inherit parallelStouffer details
#' @inherit parallelStouffer references
#' 
#' @author Aaron Lun
#' @examples
#' p1 <- rbeta(100, 0.8, 1)
#' g <- sample(10, length(p1), replace=TRUE)
#'
#' # Standard application:
#' out <- groupedStouffer(p1, g)
#' str(out)
#'
#' # With weights:
#' out <- groupedStouffer(p1, g, weights=rexp(length(p1)))
#' str(out)
#' 
#' # With log p-values. 
#' out <- groupedStouffer(log(p1), g, log.p=TRUE)
#' str(out)
#'
#' @seealso
#' \code{\link{parallelStouffer}}, for a version that operates on parallel vectors of p-values.
#'
#' \code{\link{groupedFisher}} and \code{\link{groupedPearson}}, for different approaches to testing a joint null of independent hypotheses.
#' @export
groupedStouffer <- function(p.values, grouping, weights=NULL, log.p=FALSE) {
    .grouped_compute(p.values, grouping, weights, log.p=log.p, FUN=compute_grouped_stouffer)
}

#' Count directions of parallel tests
#'
#' Count the number of parallel tests that are significant and changing in each direction.
#' Each group of tests is defined as corresponding entries across vectors.
#'
#' @param p.values A list of numeric vectors of the same length, containing the p-values to be combined.
#' @param effects A list of numeric vectors of same structure as \code{p.values}, containing the effect sizes for each set of tests.
#' @param p.threshold Numeric scalar defining the adjusted p-value threshold at which test is significant.
#' @param effect.threshold Numeric scalar defining the threshold at which an effect is \dQuote{"up"} or \dQuote{"down"}.
#' @param method String specifying how the multiple testing correction within each group is to be performed.
#' @param log.p Logical scalar indicating whether the \code{p.values} are log-transformed.
#'
#' @return A list with the \code{"up"} and \code{"down"} entries.
#' Both are integer vectors of length equal to the number of groups,
#' containing the number of significant tests changing each each direction in each group.
#'
#' @details
#' We apply a multiple testing correction within each group and define all significant tests as those with adjusted p-values below \code{p.threshold}.
#' We then count the number of tests with effects greater than \code{effect.threshold} (i.e., going up) or less than the threshold (i.e., going down).
#' This allows us to quantify the direction of change across the group into two counts.
#'
#' The output of this function is simpler to interpret than the \code{summarize*Direction} functions.
#' However, \code{p.threshold} has no clear relationship to the significance threshold applied to the combined p-values.
#' Groups with many low p-values will have milder multiplicity corrections, resulting in more non-zero counts for both the \code{up} and \code{down} tests;
#' this often complicates matters by introducing mixed directions of effect, even when the most significant changes in the group are in one direction. 
#'
#' Note that, if \code{log.p=TRUE}, the function will automatically handle the log-transformation of \code{p.threshold}.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{summarizeParallelDirection}}, for another way to summarize the overall direction into a single string.
#'
#' \code{\link{countGroupedDirection}}, for the equivalent function based on a grouping factor.
#'
#' @examples
#' p1 <- rbeta(100, 0.5, 1)
#' eff1 <- rnorm(100)
#' p2 <- rbeta(100, 0.5, 1)
#' eff2 <- rnorm(100)
#'
#' (dirs <- countParallelDirection(list(p1, p2), list(eff1, eff2)))
#'
#' @export
countParallelDirection <- function(p.values, effects, p.threshold=0.05, effect.threshold=0, method=c("BH", "holm"), log.p=FALSE) {
    .valid_parallel_pvalues(p.values)
    .valid_parallel_effects(effects)
    .valid_count_thresholds(p.threshold, effect.threshold)
    method <- match.arg(method)
    .valid_logp(log.p)

    count_parallel_direction(p.values, effects, 
        method=c(BH=0L, holm=1L)[method], 
        pthreshold=p.threshold, ethreshold=effect.threshold, log=log.p)
}

# This tests the counting functions.
# library(testthat); library(metapod); source("test-count.R")

test_that("countParallelDirection works as expected", {
    p <- list(
        rbeta(1000, 0.5, 1),
        rbeta(1000, 0.5, 1),
        rbeta(1000, 0.5, 1)
    )

    effects <- list(
        rnorm(1000),
        rnorm(1000),
        rnorm(1000)
    )

    out.bh <- countParallelDirection(p, effects)
    out.holm <- countParallelDirection(p, effects, method="holm")

    outu.bh <- outd.bh <- outu.holm <- outd.holm <- integer(1000)
    for (i in seq_len(1000)) {
        curp <- vapply(p, "[", i=i, 0)
        cure <- vapply(effects, "[", i=i, 0)

        bh.adj <- (p.adjust(curp, method="BH") < 0.05)
        outu.bh[i] <- sum(bh.adj * (cure > 0))
        outd.bh[i] <- sum(bh.adj * (cure < 0))

        holm.adj <- (p.adjust(curp, method="holm") < 0.05)
        outu.holm[i] <- sum(holm.adj * (cure > 0))
        outd.holm[i] <- sum(holm.adj * (cure < 0))
    }

    expect_identical(out.bh$up, outu.bh)
    expect_identical(out.bh$down, outd.bh)
    expect_identical(out.holm$up, outu.holm)
    expect_identical(out.holm$down, outd.holm)

    # Works for log-values.
    lout.bh <- countParallelDirection(lapply(p, log), effects, log=TRUE)
    expect_identical(out.bh, lout.bh)

    lout.holm <- countParallelDirection(lapply(p, log), effects, method="holm", log=TRUE)
    expect_identical(out.holm, lout.holm)

    # Works with NA's.
    p2 <- p
    p2[[1]][] <- NA_real_

    out.na <- countParallelDirection(p2, effects)
    ref <- countParallelDirection(p[-1], effects[-1])
    expect_identical(ref, out.na)

    out <- countParallelDirection(list(NA_real_, NA_real_, NA_real_), list(1, 0, -1))
    expect_identical(out$up, 0L)
    expect_identical(out$down, 0L)

    expect_error(countParallelDirection(p, effects[-1]), "same structure")
})

test_that("countGroupedDirection works as expected", {
    p <- rbeta(100, 0.5, 1)
    effects <- rnorm(100)
    g <- sample(50, 100, replace=TRUE)
    out <- countGroupedDirection(p, grouping=g, effects)

    # Comparing to the parallel method.
    by.g <- split(seq_along(g), g)
    outu <- outd <- integer(length(by.g))
    names(outu) <- names(outd) <- names(by.g)

    for (x in names(by.g)) {
        current <- by.g[[x]]
        ref <- countParallelDirection(as.list(p[current]), effects=as.list(effects[current]))
        outu[x] <- ref$up
        outd[x] <- ref$down
    }

    expect_identical(outu, out$up)
    expect_identical(outd, out$down)

    # Works for log-values.
    lout <- countGroupedDirection(log(p), grouping=g, effects, log=TRUE)
    expect_identical(lout, out)

    # Works for NA values.
    out <- countGroupedDirection(c(NA_real_, NA_real_, NA_real_), grouping=c(1,1,1), c(1, 0, -1))
    expect_identical(out$up[[1]], 0L)
    expect_identical(out$down[[1]], 0L)

    # Handles error states.
    expect_error(countGroupedDirection(p, rle(g[1:10]), effects), "runs.*not the same")
    expect_error(countGroupedDirection(p[1:10], rle(g), effects[1:10]), "runs.*not the same")
    expect_error(countGroupedDirection(p[1:10], g[1:10], effects), "not the same")
    expect_error(countGroupedDirection(p, g, effects[1:10]), "not the same")
})

#' Combine parallel p-values with Stouffer's Z-score
#'
#' Combine p-values from parallel tests with Stouffer's Z-score method.
#' Each group of p-values is defined from the corresponding entries across all vectors.
#'
#' @inheritParams parallelSimes
#'
#' @return A list containing:
#' \itemize{
#' \item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
#' This contains the combined Stouffer p-value for each group, log-transformed if \code{log.p=TRUE}.
#' \item \code{representative}, an integer scalar specifying the representative test in each group.
#' Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
#' \item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
#' Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
#' }
#'
#' @details
#' The joint null hypothesis for each group is that all of the individual null hypotheses are true.
#' Stouffer's method combines information from all individual nulls to determine if the joint null should be rejected.
#' This serves as a compromise between Fisher's method (sensitive to the smallest p-value) and Pearson's method (sensitive to the largest p-value).
#'
#' Stouffer's method is only applicable for independent tests.
#' Weights are supported by scaling the contribution of each individual null to the summed Z-score.
#' In this manner, more highly weighted tests will have a greater effect on the final combined p-value.
#'
#' The representative test for each group is defined as the test with the most negative weighted Z-score, 
#' as this has the greatest effect on the combined p-value when the joint null is rejected. 
#' All tests for each group are considered to be influential as increasing any of them (e.g., to unity) would result in a larger combined p-value.
#'
#' When a group contains both zero and unity p-values, we compare the sum of weights for all zero p-values and all unity p-values.
#' If the former is larger, the combined p-value is set to zero; if the latter, to unity.
#' If they are equal, we pretend that the two sets of p-values \dQuote{cancel out} and contribute nothing to the summed Z-score.
#' This is not entirely rigorous but provides reasonable output in the presence of such boundary values.
#'
#' @author Aaron Lun
#' @examples
#' p1 <- rbeta(100, 0.8, 1)
#' p2 <- runif(100)
#' p3 <- rbeta(100, 0.5, 1)
#'
#' # Standard application:
#' out <- parallelStouffer(list(p1, p2, p3))
#' str(out)
#'
#' # With weights:
#' out <- parallelStouffer(list(p1, p2, p3), weights=5:7)
#' str(out)
#'
#' # With log p-values. 
#' out <- parallelStouffer(list(log(p1), log(p2), log(p3)), log.p=TRUE)
#' str(out)
#'
#' @seealso
#' \code{\link{groupedStouffer}}, for a version that combines p-values based on a grouping factor.
#'
#' \code{\link{parallelFisher}} and \code{\link{parallelPearson}}, for different approaches to testing a joint null of independent hypotheses.
#'
#' @references
#' Stouffer SA et al. (1949).
#' \emph{The American Soldier, Vol. 1 - Adjustment during Army Life}.
#' Princeton University Press (Princeton).
#'
#' Whitlock MC (2005).
#' Combining probability from independent tests: the weighted Z-method is superior to Fisher's approach.
#' \emph{J. Evol. Biol.} 18, 5:1368-73.
#' 
#' @export
parallelStouffer <- function(p.values, weights=NULL, log.p=FALSE) {
    .valid_logp(log.p)
    .valid_parallel_pvalues(p.values)
    .valid_parallel_weights(weights)

    compute_parallel_stouffer(p.values, weights, log.p)
}

# This tests the Stouffer-related functions.
# library(metapod); library(testthat); source("setup.R"); source("test-stouffer.R")

set.seed(20000)
p1 <- runif(1000)
p2 <- runif(1000)
p3 <- runif(1000)    

REF <- function(..., weights=NULL) {
    Q <- qnorm(rbind(...))
    if (is.null(weights)) weights <- rep(1, nrow(Q))
    Q <- colSums(Q * weights)/sqrt(sum(weights^2))
    pnorm(Q)
}

test_that("parallelStouffer works correctly", {
    pout <- parallelStouffer(list(p1, p2, p3))
    expect_equal(pout$p.value, REF(p1, p2, p3)) 
    expect_equal(pout$representative, max.col(-cbind(p1, p2, p3)))
    expect_true(all(vapply(pout$influential, all, TRUE)))

    parallelTester(p1, p2, p3, FUN=parallelStouffer)

    # Handles ties correctly.
    pout <- parallelStouffer(list(p1, p2, p1))
    expect_equal(pout$p.value, REF(p1, p2, p1))

    pout <- parallelStouffer(list(p1, p1, p1))
    expect_equal(pout$p.value, REF(p1, p1, p1))

    # Works correctly with weights.
    pout <- parallelStouffer(list(p1, p2, p3), c(3,1,2))
    expect_equal(pout$p.value, REF(p1, p2, p3, weights=c(3,1,2)))
    parallelTesterWithWeights(p1, p2, p3, FUN=parallelStouffer)

    # Behaves sensibly at edge cases.
    expect_equal(parallelStouffer(list(0, 0))$p.value, 0)
    expect_equal(parallelStouffer(list(0, 1))$p.value, 0.5)
    expect_equal(parallelStouffer(list(1, 1))$p.value, 1)
})

test_that("parallelStouffer cancels out the zeros and one's", {
    expect_equal(parallelStouffer(list(0, 0, 1))$p.value, 0)
    expect_equal(parallelStouffer(list(0, 1, 1))$p.value, 1)
    expect_equal(parallelStouffer(list(0, 0.5, 1))$p.value, 0.5)

    # Works in log.p=TRUE.
    expect_equal(parallelStouffer(list(-Inf, -Inf, 0), log.p=TRUE)$p.value, -Inf)
    expect_equal(parallelStouffer(list(-Inf, 0, 0), log.p=TRUE)$p.value, 0)
    expect_equal(parallelStouffer(list(-Inf, log(0.5), 0), log.p=TRUE)$p.value, log(0.5))
})

test_that("groupedStouffer works correctly", {
    g <- sample(100, length(p1), replace=TRUE)
    groupedTester(p1, g, pFUN=parallelStouffer, gFUN=groupedStouffer)
    groupedTesterWithWeights(p1, g,  pFUN=parallelStouffer, gFUN=groupedStouffer)
})

#' Count directions of grouped tests
#'
#' Count the number of grouped tests that are significant and changing in each direction.
#' Each group of tests is defined according to a grouping factor.
#'
#' @param p.values A numeric vector containing p-values for individual tests.
#' @param grouping A vector or factor of length equal to \code{p.values}, specifying the group to which each test is assigned.
#'
#' Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{p.values} belonging to that group.
#' This assumes that \code{p.values} is ordered such that all entries in the same group are adjacent to each other.
#' @param effects A numeric vector of length equal to \code{p.values}, containing the effect size for each test.
#' @inheritParams countParallelDirection
#'
#' @inherit countParallelDirection return
#' @inherit countParallelDirection details
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{summarizeGroupedDirection}}, for another way to summarize the overall direction into a single string.
#'
#' \code{\link{countParallelDirection}}, for the equivalent function operating on parallel tests.
#'
#' @examples
#' p <- rbeta(100, 0.5, 1)
#' eff <- rnorm(100)
#' g <- sample(20, 100, replace=TRUE)
#'
#' (dirs <- countGroupedDirection(p, g, eff))
#'
#' @export
countGroupedDirection <- function(p.values, grouping, effects, p.threshold=0.05, effect.threshold=0, method=c("BH", "holm"), log.p=FALSE) {
    stopifnot(is.numeric(p.values))
    stopifnot(is.numeric(effects))
    .valid_count_thresholds(p.threshold, effect.threshold)
    method <- match.arg(method)
    .valid_logp(log.p)

    gout <- .prepare_grouped_inputs(grouping, list(p.values=p.values, effects=effects))
    p.values <- gout$x[[1]]
    effects <- gout$x[[2]]
    runs <- gout$runs

    out <- count_grouped_direction(p.values, runs$lengths, effects, 
        method=c(BH=0L, holm=1L)[method], 
        pthreshold=p.threshold, ethreshold=effect.threshold, log=log.p)
    names(out$up) <- names(out$down) <- runs$values

    out
}

#' Average parallel statistics
#'
#' Average parallel statistics with consideration of weights and protection from missing values.
#'
#' @param values A list of numeric vectors of the same length, containing statistics from parallel tests.
#' @inheritParams parallelSimes
#'
#' @details
#' If \code{weights} is supplied, a weighted average is computed for each parallel set of tests.
#' If \code{values} contains missing values, they are ignored and will not contribute to the average.
#'
#' @return A numeric vector of (weighted) averages, of length equal to the lengths of the vectors in \code{values}.
#'
#' @author Aaron Lun
#' 
#' @examples
#' averageParallelStats(list(1:10, 2:11))
#' averageParallelStats(list(1:10, 2:11), weights=c(2:1))
#' averageParallelStats(list(1:10, rep(NA, 10)))
#'
#' @seealso
#' \code{\link{averageParallelStats}}, for the parallel counterpart.
#' @export
averageParallelStats <- function(values, weights=NULL) {
    n <- unique(lengths(values))
    if (length(n)!=1){ 
        stop("all vectors in 'values' should have the same length")
    }
    if (!n) {
        return(numeric(0))
    }

    .valid_parallel_weights(weights)
    if (is.null(weights)) {
        weights <- rep(1, length(values))
    } else {
        stopifnot(length(values)==length(weights)) 
        if (is.list(weights)) {
            n2 <- unique(lengths(weights))
            if (!identical(unname(n2), unname(n))) {
                stop("'weights' must have same 'lengths' as 'values'")
            }
        }
    }

    combined <- total.weight <- 0
    for (x in seq_along(values)) {
        cur.weights <- weights[[x]]
        if (!all(cur.weights > 0)) {
            stop("'weights' must be positive")
        }

        cur.values <- values[[x]]
        product <- cur.values * cur.weights

        # Ignoring NA values and their weights.
        failed <- is.na(cur.values)
        product[failed] <- 0
        w <- ifelse(failed, 0, cur.weights)

        combined <- combined + product
        total.weight <- total.weight + w
    }

    combined/total.weight
}

# This tests the Berger-related functions.
# library(metapod); library(testthat); source("setup.R"); source("test-berger.R")

set.seed(20000)
p1 <- runif(1000)
p2 <- runif(1000)
p3 <- runif(1000)    

test_that("parallelBerger works correctly", {
    pout <- parallelBerger(list(p1, p2, p3))
    expect_equal(pout$p.value, pmax(p1, p2, p3))
    expect_equal(pout$representative, max.col(cbind(p1, p2, p3)))
    expect_true(all(vapply(pout$influential, all, TRUE)))

    parallelTester(p1, p2, p3, FUN=parallelBerger)

    # Handles ties correctly.
    pout <- parallelBerger(list(p1, p2, p1))
    expect_equal(pout$p.value, pmax(p1, p2))

    pout <- parallelBerger(list(p1, p1, p1))
    expect_equal(pout$p.value, p1)

    # Behaves sensibly at edge cases.
    expect_equal(parallelBerger(list(0, 0))$p.value, 0)
    expect_equal(parallelBerger(list(0, 1))$p.value, 1)
    expect_equal(parallelBerger(list(1, 1))$p.value, 1)
})

test_that("groupedBerger works correctly", {
    g <- sample(100, length(p1), replace=TRUE)
    groupedTester(p1, g, pFUN=parallelBerger, gFUN=groupedBerger)
})

# This tests the Pearson-related functions.
# library(metapod); library(testthat); source("setup.R"); source("test-pearson.R")

set.seed(20000)
p1 <- runif(1000)
p2 <- runif(1000)
p3 <- runif(1000)    

REFFUN <- function(...) {
    x <- cbind(...)
    Y <- rowSums(log(1-x))
    pchisq(-2*Y, df=2*ncol(x), lower.tail=TRUE)
}

test_that("parallelPearson works correctly", {
    pout <- parallelPearson(list(p1, p2, p3))

    expect_equal(pout$p.value, REFFUN(p1, p2, p3))
    expect_equal(pout$representative, max.col(cbind(p1, p2, p3)))
    expect_true(all(vapply(pout$influential, all, TRUE)))

    parallelTester(p1, p2, p3, FUN=parallelPearson)

    # Handles ties correctly.
    pout <- parallelPearson(list(p1, p2, p1))
    expect_equal(pout$p.value, REFFUN(p1, p1, p2))

    pout <- parallelPearson(list(p1, p1, p1))
    expect_equal(pout$p.value, REFFUN(p1, p1, p1))

    # Behaves sensibly at edge cases.
    expect_equal(parallelPearson(list(0, 0))$p.value, 0)
    expect_equal(parallelPearson(list(0, 1))$p.value, 1)
    expect_equal(parallelPearson(list(1, 1))$p.value, 1)
})

test_that("groupedPearson works correctly", {
    g <- sample(100, length(p1), replace=TRUE)
    groupedTester(p1, g, pFUN=parallelPearson, gFUN=groupedPearson)
})

parallelTester <- function(p1, p2, p3, FUN) {
    all.p <- list(p1, p2, p3)

    ref <- FUN(all.p)
    infmat <- do.call(cbind, ref$influential)
    out <- infmat[cbind(seq_len(nrow(infmat)), ref$representative)]
    expect_true(all(out))

    # Behaves properly upon logging.
    out <- FUN(lapply(all.p, log), log.p=TRUE)
    expect_equal(log(ref$p.value), out$p.value)
    expect_equal(ref$reference, out$reference)
    expect_equal(ref$influential, out$influential)

    # Handles solo inputs.
    for (i in seq_along(all.p)) {
        current <- FUN(all.p[i])
        expect_equal(all.p[[i]], current$p.value)
        expect_true(all(current$representative==1))
        expect_true(all(current$influential[[1]]))
    }

    # Handles empty inputs.
    empty <- FUN(lapply(all.p, "[", i=0))
    expect_equal(empty$p.value, numeric(0))

    # Throws on invalid inputs.
    expect_error(FUN(list(p1, p2[0])), "same length")

    # Handles partial NA values correctly.
    some.na <- sample(length(p1), length(p1)/2)
    p1.na <- p1
    p1.na[some.na] <- NA
    p2.na <- p2
    p2.na[-some.na] <- NA

    ref <- FUN(list(p1, p3))
    ref2 <- FUN(list(p2, p3))
    direct <- FUN(list(p1.na, p2.na, p3))

    refp <- ref$p.value
    refp[some.na] <- ref2$p.value[some.na]
    expect_equal(refp, direct$p.value)

    refr <- c(1L, 3L)[ref$representative]
    refr[some.na] <- ref2$representative[some.na] + 1L
    expect_equal(refr, direct$representative)

    # Handles all-NA values correctly.
    p1.na <- p1
    p2.na <- p2
    p3.na <- p3
    p1.na[1] <- p2.na[1] <- p3.na[1] <- NA_real_
    out <- FUN(list(p1.na, p2.na, p3.na))

    expect_true(is.na(out$p.value[1]))
    expect_true(is.na(out$representative[1]))
    expect_false(any(vapply(out$influential, "[", i=1, FALSE)))

    expect_false(any(is.na(out$p.value[-1])))
    expect_false(any(is.na(out$representative[-1])))
    expect_true(all(Reduce("|", lapply(out$influential, "[", i=-1))))

    TRUE
}

parallelTesterWithWeights <- function(p1, p2, p3, FUN) {
    all.p <- list(p1, p2, p3)
    ref <- FUN(all.p)

    # Checking that weights are actually respected.
    weights <- runif(3)
    out <- FUN(all.p, weights=weights)
    expect_false(isTRUE(all.equal(out,ref)))

    expect_error(FUN(all.p, weights=weights[1]), "length.*should be equal")
    expect_error(FUN(all.p, weights=-(1:3)), "must be positive")

    # Checking that list-like weights are handled properly.
    weights2 <- runif(3)
    out <- FUN(lapply(all.p, "[", i=1:10), weights=weights)
    out2 <- FUN(lapply(all.p, "[", i=11:15), weights=weights2)

    lweights <- mapply(c,
        lapply(weights, rep, each=10),
        lapply(weights2, rep, each=5),
        SIMPLIFY=FALSE
    )
    sub <- lapply(all.p, "[", i=1:15)
    combined <- FUN(sub, weights=lweights)

    expect_equal(combined$p.value, c(out$p.value, out2$p.value))
    expect_equal(combined$representative, c(out$representative, out2$representative))

    expect_error(FUN(all.p, weights=lweights), "length.*should be equal")
    expect_error(FUN(sub, weights=lapply(lweights, function(x) -x)), "must be positive")
    expect_error(FUN(sub, weights=lapply(lweights, function(x) x * NA)), "must be positive")
    expect_error(FUN(all.p, weights=rep(NA_real_, length(all.p))), "must be positive")

    # Weights and NA's interact correctly.
    weights <- runif(3)
    p1.na <- p1
    p1.na[] <- NA
    out <- FUN(list(p1.na, p2, p3), weights=weights)
    ref <- FUN(list(p2, p3), weights=weights[-1])

    expect_identical(out$p.value, ref$p.value)
    expect_identical(out$representative, ref$representative + 1L)
    expect_false(any(out$influential[[1]]))
    expect_identical(out$influential[-1], ref$influential)

    TRUE
}

groupedTester <- function(p, g, gFUN, pFUN) {
    ref <- gFUN(p, g)

    # Logging works.
    lout <- gFUN(log(p), g, log.p=TRUE)
    lout$p.value <- exp(lout$p.value)
    expect_equal(ref, lout)

    # RLE mode works.
    o <- order(g)
    out <- gFUN(p[o], rle(g[o]))
    out$representative[] <- o[out$representative]
    out$influential[o] <- out$influential
    expect_identical(out, ref)

    # Character vector and factors work.
    alt <- gFUN(p, as.character(g))
    alt$p.value <- alt$p.value[order(as.integer(names(alt$p.value)))]
    alt$representative <- alt$representative[order(as.integer(names(alt$representative)))]
    expect_identical(ref, alt)

    moreg <- factor(g)
    standard <- gFUN(p, moreg)
    expect_identical(ref, standard)
    moreg <- factor(g, levels=rev(levels(moreg)))
    alt <- gFUN(p, moreg)
    expect_identical(alt$p.value, rev(standard$p.value))

    moreg <- factor(g, levels=c(unique(g), "special"))
    alt <- gFUN(p, moreg)
    expect_identical(alt$p.value[["special"]], NA_real_)

    # Manual looping to compare to parallel function.
    by.g <- split(seq_along(p), g)
    outp <- numeric(length(by.g))
    outrep <- integer(length(by.g))
    outinf <- logical(length(g))

    for (i in seq_along(by.g)) {
        current <- by.g[[i]]
        single <- pFUN(as.list(p[current]))
        outp[i] <- single$p.value
        outrep[i] <- current[single$representative]
        outinf[current] <- unlist(single$influential)
    }

    names(outp) <- names(outrep) <- names(by.g)
    expect_equal(outp, ref$p.value)
    expect_equal(outrep, ref$representative)
    expect_equal(outinf, ref$influential)

    # Robust to NA's.
    thrown <- sample(length(p), length(p)/2)
    p2 <- p
    p2[-thrown] <- NA

    has.na <- gFUN(p2, g)
    expect_identical(names(has.na), names(ref))

    nullified <- gFUN(p[thrown], g[thrown])
    commong <- as.character(sort(unique(g[thrown])))
    expect_identical(commong, names(nullified$p.value)) 
    expect_equal(has.na$p.value[commong], nullified$p.value)
    expect_equivalent(has.na$representative[commong], thrown[nullified$representative])
    expect_identical(has.na$influential[thrown], nullified$influential)

    lost <- setdiff(names(has.na$p.value), commong)
    expect_true(all(is.na(has.na$p.value[lost])))
    expect_true(all(is.na(has.na$representative[lost])))
    expect_false(any(has.na$influential[-thrown]))

    # Robust to extreme NA's.
    p2 <- p
    p2[g == g[1]] <- NA
    has.na <- gFUN(p2, g)

    grp <- as.character(g[1])
    expect_true(is.na(has.na$p.value[grp]))
    expect_true(is.na(has.na$representative[grp]))
    expect_false(any(has.na$influential[g == g[1]]))

    TRUE
}

groupedTesterWithWeights <- function(p, g, gFUN, pFUN) {
    w <- rexp(length(p))
    ref <- gFUN(p, g, weights=w)
    out <- gFUN(p, g)
    expect_false(isTRUE(all.equal(out,ref))) # weights actually have an effect.
    
    # Manual looping to compare to parallel function.
    by.g <- split(seq_along(p), g)
    outp <- numeric(length(by.g))
    outrep <- integer(length(by.g))
    outinf <- logical(length(g))

    for (i in seq_along(by.g)) {
        current <- by.g[[i]]
        single <- pFUN(as.list(p[current]), weights=as.list(w[current]))
        outp[i] <- single$p.value
        outrep[i] <- current[single$representative]
        outinf[current] <- unlist(single$influential)
    }

    names(outp) <- names(outrep) <- names(by.g)
    expect_equal(outp, ref$p.value)
    expect_equal(outrep, ref$representative)
    expect_equal(outinf, ref$influential)

    # Weights and NA's interact correctly.
    thrown <- sample(length(p), length(p)/2)
    p2 <- p
    p2[-thrown] <- NA

    has.na <- gFUN(p2, g, weights=w)
    expect_identical(names(has.na), names(ref))

    nullified <- gFUN(p[thrown], g[thrown], weights=w[thrown])
    commong <- as.character(sort(unique(g[thrown])))
    expect_identical(commong, names(nullified$p.value)) 
    expect_equal(has.na$p.value[commong], nullified$p.value)
    expect_equivalent(has.na$representative[commong], thrown[nullified$representative])
    expect_identical(has.na$influential[thrown], nullified$influential)

    expect_error(gFUN(p, g, weights=-w), "must be positive")
    expect_error(gFUN(p, g, weights=w * NA), "must be positive")

    TRUE
}

---
title: Meta-analyses on p-values of various differential tests
author: 
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
date: "Revised: 1 November 2020"
output:
  BiocStyle::html_document:
    toc_float: true
package: metapod
vignette: >
  %\VignetteIndexEntry{Meta-analysis strategies}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}    
---

```{r, echo=FALSE, results="hide", message=FALSE}
require(knitr)
opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)
library(BiocStyle)
```

# Overview

The `r Biocpkg("metapod")` package provides utilities for meta-analyses on precomputed $p$-values, typicall generated from differential analyses of some sort.
This enables users to consolidate multiple related tests into a single metric for easier interpretation and prioritization of interesting events.
The functionality here was originally developed as part of the `r Biocpkg("csaw")` package, to combine inferences from adjacent windows inside a genomic region;
as well as from the `r Biocpkg("scran")` package, to merge statistics from multiple batches or from multiple pairwise comparisons during marker gene detection.
Most functions in this package involve combining multiple (independent or not) $p$-values into a single combined $p$-value.
Additional functions are also provided to summarize the direction of any effect.

# Meta-analyses on $p$-values

`r Biocpkg("metapod")` provides two families of functions to combine a group of $p$-values into a single statistic.
The first family considers parallel vectors of $p$-values where each group of $p$-values is defined from corresponding elements across vectors.
This is useful for combining different tests on the same set of features, e.g., DE analyses with the same gene annotation. 
We illustrate this below by using Simes' method to combine two parallel vectors:

```{r}
library(metapod)
p1 <- rbeta(10000, 0.5, 1)
p2 <- rbeta(10000, 0.5, 1)
par.combined <- parallelSimes(list(p1, p2))
str(par.combined)
```

The other approach is to consider groups of $p$-values within a single numeric vector.
This is useful when the $p$-values to be combined are generated as part of a single analysis.
The motivating example is that of adjacent windows in the same genomic region for ChIP-seq,
but one can also imagine the same situation for other features, e.g., exons in RNA-seq.
In this situation, we need a grouping factor to define the groups within our vector:

```{r}
p <- rbeta(10000, 0.5, 1)
g <- sample(100, length(p), replace=TRUE)
gr.combined <- groupedSimes(p, g)
str(gr.combined)
```

Both families of functions return the combined $p$-value along with some other helpful statistics.
The `representative` vector specifies the index of the representative test for each group;
this is a test that is particularly important to the calculation of the combined $p$-value and can be used to, e.g., obtain a representative effect size. 
Similarly, the `influential` vector indicates which of the individual tests in each group are "influential" in computing the combined $p$-value.
This is defined as the subset of tests that, if their $p$-values were set to unity, would alter the combined $p$-value.

# $p$-value combining strategies

The following methods yield a significant result for groups where **any** of the individual tests are significant:

- Simes' method (`parallelSimes()` and `groupedSimes()`) is robust to dependencies between tests and supports weighting of individual tests.
- Fisher's method (`parallelFisher()` and `groupedFisher()`) assumes that tests are independent and does not support weighting.
- Pearson's method (`parallelPearson()` and `groupedPearson()`) assumes that tests are independent and does not support weighting.
- Stouffer's Z-score method (`parallelStouffer()` and `groupedStouffer()`) assumes that tests are independent and does support weighting.

Fisher's method is most sensitive to the smallest $p$-value while Pearson's method is most sensitive to the largest $p$-value.
Stouffer's method serves as a compromise between these two extremes.
Simes' method is more conservative than all three but is still functional in the presence of dependencies.

The following methods yield a significant result for groups where **some** of the individual tests are significant
(i.e., a minimum number or proportion of individual tests reject the null hypothesis):

- Wilkinson's method (`parallelWilkinson()` and `groupedWilkinson()`) assumes that tests are independent and does not support weighting.
- The minimum Holm approach (`parallelHolmMin()` and `groupedHolmMin()`) does not require independence and supports weighting.

Technically, Wilkinson's method can reject if any of the individual nulls are significant.
However, it has a dramatic increase in detection power when the specified minimum is attained, hence its inclusion in this category.

Finally, Berger's intersection union test will yield a significant result for groups where **all** of the individual tests are significant.
This does not require independence but does not support weighting.

# Summarizing the direction

The `summarizeParallelDirection()` and `summarizeGroupedDirection()` functions will summarize the direction of effect of all influential tests for each group.
For example, if all influential tests have positive log-fold changes, the group would be reported as having a direction of `"up"`.
Alternatively, if influential tests have both positive and negative log-fold changes, the reported direction would be `"mixed"`.
By only considering the influential tests, we avoid noise from "less significant" tests that do not contribute to the final $p$-value.

```{r}
logfc1 <- rnorm(10000)
logfc2 <- rnorm(10000)

par.dir <- summarizeParallelDirection(list(logfc1, logfc2), 
    influential = par.combined$influential)
table(par.dir)
```

`countParallelDirection()` and `countGroupedDirection` will just count the number of significant tests changing in each direction.
This is done after correcting for the number of tests in each group with the Benjamini-Hochberg or Holm methods.
These counts are somewhat simpler to interpret than the summarized direction but have their own caveats - see `?countParallelDirection` for details.

```{r}
par.dir2 <- countParallelDirection(list(p1, p2), list(logfc1, logfc2)) 
str(par.dir2)
```

Another approach is to just use the direction of effect of the representative test.
This is usually the best approach if a single direction and effect size is required, e.g., for visualization purposes.

# Further comments

All functions support `log.p=TRUE` to accept log-transformed $p$-values as input and to return log-transformed output.
This is helpful in situations where underflow would cause generation of zero $p$-values.

Several functions support weighting of the individual tests within each group.
This is helpful if some of the tests are _a priori_ known to be more important than others.

The `combineParallelPValues()` and `combineGroupedPValues()` wrapper functions will dispatch to the requested `method`,
making it easier to switch between methods inside other packages:

```{r}
gr.combined2 <- combineGroupedPValues(p, g, method="holm-min")
str(gr.combined2)
```

# Session information {-}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/groupedHolmMin.R
\name{groupedHolmMin}
\alias{groupedHolmMin}
\title{Combine grouped p-values with the minimum Holm approach}
\usage{
groupedHolmMin(
  p.values,
  grouping,
  weights = NULL,
  log.p = FALSE,
  min.n = 1,
  min.prop = 0.5
)
}
\arguments{
\item{p.values}{A numeric vector containing p-values for individual tests.}

\item{grouping}{A vector or factor of length equal to \code{p.values}, specifying the group to which each test is assigned.

Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{p.values} belonging to that group.
This assumes that \code{p.values} is ordered such that all entries in the same group are adjacent to each other.}

\item{weights}{A numeric vector of length equal to \code{p.values}, containing a positive weight for each test.
Alternatively \code{NULL}, in which case equal weights are assigned to all tests.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}

\item{min.n}{Integer scalar specifying the minimum number of individual nulls to reject when testing the joint null.}

\item{min.prop}{Numeric scalar in [0, 1], specifying the minimum proportion of individual nulls to reject when testing the joint null.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a named numeric vector of length equal to the number of unique levels in \code{grouping}.
This contains the minimum Holm p-value for each group, log-transformed if \code{log.p=TRUE}.
Each entry is named according to the group.
\item \code{representative}, a named integer scalar specifying the representative test for each group.
Each index refers to an entry of \code{p.values} and is named according to its group.
\item \code{influential}, a logical vector of length equal to \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value for its group.
}
}
\description{
Combine p-values from grouped tests with the minimum Holm approach.
Groups are defined according to unique levels of a grouping factor.
}
\details{
Here, the joint null hypothesis for each group is that fewer than \eqn{N} individual null hypotheses are false.
The joint null is only rejected if \eqn{N} or more individual nulls are rejected; hence the \dQuote{minimum} in the function name.

\eqn{N} is defined as the larger of \code{min.n} and the product of \code{min.prop} with the number of tests in the group (rounded up).
This allows users to scale rejection of the joint null with the size of the group, while avoiding a too-low \eqn{N} when the group is small.
Note that \eqn{N} is always capped at the total size of the group.

To compute the combined p-value, we apply the Holm-Bonferroni correction to all p-values in the set and take the \eqn{N}-th smallest value.
This effectively recapitulates the step-down procedure where we reject individual nulls until we reach the \eqn{N}-th test.
This method works correctly in the presence of dependencies between p-values.

If non-equal weights are provided, they are used to effectively downscale the p-values. 
This aims to redistribute the error rate across the individual tests,
i.e., tests with lower weights are given fewer opportunities to drive acceptance of the joint null.

The representative test for each group is defined as that with the \eqn{N}-th smallest p-value, as this is directly used as the combined p-value.
The influential tests for each group are defined as those with p-values no greater than the representative test's p-value.
This is based on the fact that increasing them (e.g., by setting them to unity) would result in a larger combined p-value.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
g <- sample(10, length(p1), replace=TRUE)

# Standard application:
out <- groupedHolmMin(p1, g)
str(out)

# With weights:
out <- groupedHolmMin(p1, g, weights=rexp(length(p1)))
str(out)

# With log p-values. 
out <- groupedHolmMin(log(p1), g, log.p=TRUE)
str(out)

}
\references{
Holm S (1979).
A simple sequentially rejective multiple test procedure.
\emph{Scand. J. Stat.} 6, 65-70.
}
\seealso{
\code{\link{parallelHolmMin}}, for a version that operates on parallel vectors of p-values.

\code{\link{groupedWilkinson}}, for a more relaxed version of this test when hypotheses are independent.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/averageGroupedStats.R
\name{averageGroupedStats}
\alias{averageGroupedStats}
\title{Average grouped statistics}
\usage{
averageGroupedStats(values, grouping, weights = NULL)
}
\arguments{
\item{values}{A numeric vector containing statistics for individual tests.}

\item{grouping}{A vector or factor of length equal to \code{p.values}, specifying the group to which each test is assigned.

Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{p.values} belonging to that group.
This assumes that \code{p.values} is ordered such that all entries in the same group are adjacent to each other.}

\item{weights}{A numeric vector of length equal to \code{p.values}, containing a positive weight for each test.
Alternatively \code{NULL}, in which case equal weights are assigned to all tests.}
}
\value{
A named numeric vector of (weighted) averages, of length equal to the number of unique levels in \code{grouping}.
}
\description{
Average grouped statistics with consideration of weights and protection from missing values.
}
\details{
If \code{weights} is supplied, a weighted average is computed for each group.
If \code{values} contains missing values, they are ignored and will not contribute to the average.
}
\examples{
grouping <- sample(LETTERS, 20, replace=TRUE)
averageGroupedStats(1:20, grouping)
averageGroupedStats(1:20, grouping, weights=runif(20))

}
\seealso{
\code{\link{averageParallelStats}}, for the parallel counterpart.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combineGroupedPValues.R
\name{combineGroupedPValues}
\alias{combineGroupedPValues}
\title{Combine grouped p-values}
\usage{
combineGroupedPValues(
  p.values,
  grouping,
  method = c("simes", "holm-min", "berger", "fisher", "pearson", "wilkinson",
    "stouffer"),
  weights = NULL,
  log.p = FALSE,
  min.n = 1,
  min.prop = 0.5
)
}
\arguments{
\item{p.values}{A numeric vector containing p-values for individual tests.}

\item{grouping}{A vector or factor of length equal to \code{p.values}, specifying the group to which each test is assigned.

Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{p.values} belonging to that group.
This assumes that \code{p.values} is ordered such that all entries in the same group are adjacent to each other.}

\item{method}{String specifying the method to use to combine p-values.}

\item{weights}{A numeric vector of length equal to \code{p.values}, containing a positive weight for each test.
Alternatively \code{NULL}, in which case equal weights are assigned to all tests.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}

\item{min.n}{Integer scalar specifying the minimum number of individual nulls to reject when testing the joint null.}

\item{min.prop}{Numeric scalar in [0, 1], specifying the minimum proportion of individual nulls to reject when testing the joint null.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a named numeric vector of length equal to the number of unique levels in \code{grouping}.
This contains the combined p-value for each group, log-transformed if \code{log.p=TRUE}.
Each entry is named according to the group.
\item \code{representative}, a named integer scalar specifying the index of representative test for each group.
Each index refers to an entry of \code{p.values} and is named according to its group.
\item \code{influential}, a logical vector of length equal to \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value for its group.
}
}
\description{
Combine p-values from grouped hypothesis tests using a variety of meta-analysis methods.
Each group of p-values is defined as those assigned to the same level of the grouping factor.
}
\details{
\code{min.prop} and \code{min.n} only have an effect for \code{method="wilkinson"} and \code{"holm-min"}.

\code{weights} only has an effect for \code{method="simes"}, \code{"holm-min"} and \code{"stouffer"}.
}
\examples{
p <- runif(10000)
g <- sample(100, 10000, replace=TRUE)

fish <- combineGroupedPValues(p, g, method="fisher")
hist(fish$p.value)

z <- combineGroupedPValues(p, g, method="stouffer", weights=rexp(10000))
hist(z$p.value)

simes <- combineGroupedPValues(p, g, method="simes")
hist(simes$p.value)

berger <- combineGroupedPValues(p, g, method="berger")
hist(berger$p.value)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parallelSimes.R
\name{parallelSimes}
\alias{parallelSimes}
\title{Combine parallel p-values with Simes' method}
\usage{
parallelSimes(p.values, weights = NULL, log.p = FALSE)
}
\arguments{
\item{p.values}{A list of numeric vectors of the same length, containing the p-values to be combined.}

\item{weights}{A numeric vector of positive weights, with one value per vector in \code{...}.
Each weight is applied to all entries of itscorresponding vector, i.e., all p-values in that vector receive the same weight.

Alternatively, a list of numeric vectors of weights with the same structure as \code{p.values}.
Each p-value is then assigned the weight in the corresponding entry of \code{weights}.

Alternatively \code{NULL}, in which case all p-values are assigned equal weight.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
This contains the combined Simes p-value for each group, log-transformed if \code{log.p=TRUE}.
\item \code{representative}, an integer scalar specifying the representative test in each group.
Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
\item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
}
}
\description{
Combine p-values from parallel tests with Simes' method.
Each group of p-values is defined from the corresponding entries across all vectors.
}
\details{
The joint null hypothesis for each group is that all of the individual null hypotheses are true.
Simes' method will reject the joint null if any of the individual nulls are rejected, providing weak control of the family-wise error rate.

In theory, the method is only applicable to independent tests, but experience suggests that it is quite robust to dependencies.
The calculation itself is very closely related to the Benjamini-Hochberg method for controlling the false discovery rate.
One can actually obtain Simes' combined p-value by taking the smallest BH-adjusted p-value across a group.

If non-equal weights are provided, they are treated as relative frequency weights.
That is, if one p-value is given a weight of 10 and another p-value is given a weight of 1, 
the former is considered to occur 10 times more frequently than the latter.

The representative test for each group is defined as the test with the p-value that is ultimately used as the combined p-value.
Briefly, one can identify this test as that with the smallest BH-adjusted p-value if the monotonicity adjustment were omitted.
The influential tests for each group are defined as those with p-values no greater than the representative test's p-value.
This is based on the fact that increasing them (e.g., by setting them to unity) would result in a larger combined p-value.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
p2 <- runif(100)
p3 <- rbeta(100, 0.5, 1)

# Standard application:
out <- parallelSimes(list(p1, p2, p3))
str(out)

# With vector-level weights:
out <- parallelSimes(list(p1, p2, p3), weights=c(10, 20, 30))
str(out)

# With log p-values. 
out <- parallelSimes(list(log(p1), log(p2), log(p3)), log.p=TRUE)
str(out)

}
\references{
Simes RJ (1986).
An improved Bonferroni procedure for multiple tests of significance.
\emph{Biometrika} 73:751-754.

Sarkar SK and Chung CK (1997).
The Simes method for multiple hypothesis testing with positively dependent test statistics.
\emph{J. Am. Stat. Assoc.} 92, 1601-1608.

Benjamini Y and Hochberg Y (1997).
Multiple hypotheses testing with weights.
\emph{Scand. J. Stat.} 24, 407-418.
}
\seealso{
\code{\link{groupedSimes}}, for a version that combines p-values based on a grouping factor.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarizeParallelDirection.R
\name{summarizeParallelDirection}
\alias{summarizeParallelDirection}
\title{Summarize overall direction of parallel tests}
\usage{
summarizeParallelDirection(effects, influential, threshold = 0)
}
\arguments{
\item{effects}{A list of numeric vectors of the same length, containing the effect sizes for each set of tests.
Each group of tests is defined as corresponding entries across vectors.}

\item{influential}{A list of logical vectors with the same structure as \code{effects},
specifying the tests that are influential to the final per-group p-value.}

\item{threshold}{Numeric scalar defining the threshold at which an effect is \dQuote{"up"} or \dQuote{"down"}.}
}
\value{
A character vector of length equal to the number of groups.
Each entry can be:
\itemize{
\item \code{"up"}, if all influential tests have effects above \code{threshold}.
\item \code{"down"}, if all influential tests have effects below \code{threshold}.
\item \code{"none"}, if all influential tests have effects equal to \code{threshold}.
\item \code{"mixed"}, if there are influential tests with effects above and below \code{threshold}.
}
}
\description{
Summarize the overall direction of parallel tests in a meta-analysis,
based on the influential tests defined by one of the \code{parallel*} functions.
}
\details{
We focus on the direction of effect for the influential tests that actually contribute to a group's final p-value.
For example, if we did our meta-analysis using \code{\link{parallelSimes}},we are not particularly concerned about the direction of tests with large p-values.
Thus, we just ignore them when summarizing the group's direction in this function.
Otherwise, we would unnecessarily obtain a \code{mixed} direction of effect if a test with a large p-value had a weakly opposing effect.

Of course, the interpretation of \dQuote{influential} really depends on the choice of meta-analysis strategy.
It is also possible that this function reports a single direction when the group really is mixed,
e.g., if the tests with the lowest p-values are changing in one direction but tests with weaker but still interesting effects are changing in the other direction.
The extent to which this is of interest is left to the discretion of the user.
}
\examples{
p1 <- rbeta(100, 0.5, 1)
eff1 <- rnorm(100)
p2 <- rbeta(100, 0.5, 1)
eff2 <- rnorm(100)

out <- parallelSimes(list(p1, p2))
(dir <- summarizeParallelDirection(list(eff1, eff2), out$influential))

}
\seealso{
\code{\link{parallelSimes}} and related \code{parallel*} functions, to obtain \code{influential}.

\code{\link{summarizeGroupedDirection}}, for the equivalent function based on a grouping factor.

\code{\link{countParallelDirection}}, to count the number of effects in each direction.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parallelWilkinson.R
\name{parallelWilkinson}
\alias{parallelWilkinson}
\title{Combine p-values with Wilkinson's method}
\usage{
parallelWilkinson(p.values, log.p = FALSE, min.n = 1, min.prop = 0.5)
}
\arguments{
\item{p.values}{A list of numeric vectors of the same length, containing the p-values to be combined.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}

\item{min.n}{Integer scalar specifying the minimum number of individual nulls to reject when testing the joint null.}

\item{min.prop}{Numeric scalar in [0, 1], specifying the minimum proportion of individual nulls to reject when testing the joint null.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
This contains the combined p-value for each group, log-transformed if \code{log.p=TRUE}.
\item \code{representative}, an integer scalar specifying the representative test in each group.
Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
\item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final per-group p-value.
}
}
\description{
Combine p-values from parallel tests with Wilkinson's method.
Each group of p-values is defined from the corresponding entries across all vectors.
The function processes all vectors \dQuote{in parallel} - hence the name.
}
\details{
Here, the joint null hypothesis for each group is all individual null hypotheses are false.
Rejection of the joint null is heavily favored in situations where \eqn{N} or more individual nulls are rejected.
This is achieved in Wilkinson's method by considering the \eqn{N}-th order statistic for uniformly distributed p-values.
The individual tests are assumed to be independent, and all weights are ignored.

\eqn{N} is defined as the larger of \code{min.n} and the product of \code{min.prop} with the number of tests in the group (rounded up).
This allows users to scale rejection of the joint null with the size of the group, while avoiding a too-low \eqn{N} when the group is small.
Note that \eqn{N} is always capped at the total size of the group.

The representative test for each group is defined as that with the \eqn{N}-th smallest p-value, as this is used to compute the combined p-value.
The influential tests for each group are defined as those with p-values no greater than the representative test's p-value.
This is based on the fact that increasing them (e.g., by setting them to unity) would result in a larger combined p-value.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
p2 <- runif(100)
p3 <- rbeta(100, 0.5, 1)

# Standard application:
out <- parallelWilkinson(list(p1, p2, p3))
str(out)

# With log p-values. 
out <- parallelWilkinson(list(log(p1), log(p2), log(p3)), log.p=TRUE)
str(out)

}
\references{
Wilkinson B (1951).
A statistical consideration in psychological research.
\emph{Psychol. Bull.} 48, 156-158.
}
\seealso{
\code{\link{groupedWilkinson}}, for a version that combines p-values based on a grouping factor.

\code{\link{parallelHolmMin}}, which has a more strict interpretation of \emph{N}, amongst other things.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/averageParallelStats.R
\name{averageParallelStats}
\alias{averageParallelStats}
\title{Average parallel statistics}
\usage{
averageParallelStats(values, weights = NULL)
}
\arguments{
\item{values}{A list of numeric vectors of the same length, containing statistics from parallel tests.}

\item{weights}{A numeric vector of positive weights, with one value per vector in \code{...}.
Each weight is applied to all entries of itscorresponding vector, i.e., all p-values in that vector receive the same weight.

Alternatively, a list of numeric vectors of weights with the same structure as \code{p.values}.
Each p-value is then assigned the weight in the corresponding entry of \code{weights}.

Alternatively \code{NULL}, in which case all p-values are assigned equal weight.}
}
\value{
A numeric vector of (weighted) averages, of length equal to the lengths of the vectors in \code{values}.
}
\description{
Average parallel statistics with consideration of weights and protection from missing values.
}
\details{
If \code{weights} is supplied, a weighted average is computed for each parallel set of tests.
If \code{values} contains missing values, they are ignored and will not contribute to the average.
}
\examples{
averageParallelStats(list(1:10, 2:11))
averageParallelStats(list(1:10, 2:11), weights=c(2:1))
averageParallelStats(list(1:10, rep(NA, 10)))

}
\seealso{
\code{\link{averageParallelStats}}, for the parallel counterpart.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/groupedSimes.R
\name{groupedSimes}
\alias{groupedSimes}
\title{Combine grouped p-values with Simes' method}
\usage{
groupedSimes(p.values, grouping, weights = NULL, log.p = FALSE)
}
\arguments{
\item{p.values}{A numeric vector containing p-values for individual tests.}

\item{grouping}{A vector or factor of length equal to \code{p.values}, specifying the group to which each test is assigned.

Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{p.values} belonging to that group.
This assumes that \code{p.values} is ordered such that all entries in the same group are adjacent to each other.}

\item{weights}{A numeric vector of length equal to \code{p.values}, containing a positive weight for each test.
Alternatively \code{NULL}, in which case equal weights are assigned to all tests.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a named numeric vector of length equal to the number of unique levels in \code{grouping}.
This contains the combined Simes p-value for each group, log-transformed if \code{log.p=TRUE}.
Each entry is named according to the group.
\item \code{representative}, a named integer scalar specifying the index of representative test for each group.
Each index refers to an entry of \code{p.values} and is named according to its group.
\item \code{influential}, a logical vector of length equal to \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value for its group.
}
}
\description{
Combine p-values from grouped tests with Simes' method.
Groups are defined according to unique levels of a grouping factor.
}
\details{
The joint null hypothesis for each group is that all of the individual null hypotheses are true.
Simes' method will reject the joint null if any of the individual nulls are rejected, providing weak control of the family-wise error rate.

In theory, the method is only applicable to independent tests, but experience suggests that it is quite robust to dependencies.
The calculation itself is very closely related to the Benjamini-Hochberg method for controlling the false discovery rate.
One can actually obtain Simes' combined p-value by taking the smallest BH-adjusted p-value across a group.

If non-equal weights are provided, they are treated as relative frequency weights.
That is, if one p-value is given a weight of 10 and another p-value is given a weight of 1, 
the former is considered to occur 10 times more frequently than the latter.

The representative test for each group is defined as the test with the p-value that is ultimately used as the combined p-value.
Briefly, one can identify this test as that with the smallest BH-adjusted p-value if the monotonicity adjustment were omitted.
The influential tests for each group are defined as those with p-values no greater than the representative test's p-value.
This is based on the fact that increasing them (e.g., by setting them to unity) would result in a larger combined p-value.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
g <- sample(10, length(p1), replace=TRUE)

# Standard application:
out <- groupedSimes(p1, g)
str(out)

# With weights:
out <- groupedSimes(p1, g, weights=rexp(length(p1)))
str(out)

# With log p-values. 
out <- groupedSimes(log(p1), g, log.p=TRUE)
str(out)

}
\references{
Simes RJ (1986).
An improved Bonferroni procedure for multiple tests of significance.
\emph{Biometrika} 73:751-754.

Sarkar SK and Chung CK (1997).
The Simes method for multiple hypothesis testing with positively dependent test statistics.
\emph{J. Am. Stat. Assoc.} 92, 1601-1608.

Benjamini Y and Hochberg Y (1997).
Multiple hypotheses testing with weights.
\emph{Scand. J. Stat.} 24, 407-418.
}
\seealso{
\code{\link{parallelSimes}}, for a version that operates on parallel vectors of p-values.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parallelBerger.R
\name{parallelBerger}
\alias{parallelBerger}
\title{Combine parallel p-values with Berger's IUT}
\usage{
parallelBerger(p.values, log.p = FALSE)
}
\arguments{
\item{p.values}{A list of numeric vectors of the same length, containing the p-values to be combined.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
This contains the IUT p-value for each group, log-transformed if \code{log.p=TRUE}.
\item \code{representative}, an integer scalar specifying the representative test in each group.
Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
\item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
}
}
\description{
Combine p-values from parallel tests with Berger's intersection-union test (IUT).
Each group of p-values is defined from the corresponding entries across all vectors.
}
\details{
The joint null hypothesis for each group is that \emph{any} of the individual null hypotheses are true.
Berger's IUT will only reject the joint null if all of the individual nulls are rejected.
This method is applicable under arbitrary dependency structures.
No weights are considered.

The representative test for each group is defined as the test with the largest p-value, as this is ultimately used as the IUT p-value.
All tests for each group are considered to be influential as increasing any of them (e.g., to unity) would result in a larger combined p-value.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
p2 <- runif(100)
p3 <- rbeta(100, 0.5, 1)

# Standard application:
out <- parallelBerger(list(p1, p2, p3))
str(out)

# With log p-values. 
out <- parallelBerger(list(log(p1), log(p2), log(p3)), log.p=TRUE)
str(out)

}
\references{
Berger RL and Hsu JC (1996).
Bioequivalence trials, intersection-union tests and equivalence confidence sets.
\emph{Statist. Sci.} 11, 283-319.
}
\seealso{
\code{\link{groupedBerger}}, for the version that combines p-values based on a grouping factor.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/groupedFisher.R
\name{groupedFisher}
\alias{groupedFisher}
\title{Combine grouped p-values with Fisher's method}
\usage{
groupedFisher(p.values, grouping, log.p = FALSE)
}
\arguments{
\item{p.values}{A numeric vector containing p-values for individual tests.}

\item{grouping}{A vector or factor of length equal to \code{p.values}, specifying the group to which each test is assigned.

Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{p.values} belonging to that group.
This assumes that \code{p.values} is ordered such that all entries in the same group are adjacent to each other.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a named numeric vector of length equal to the number of unique levels in \code{grouping}.
This contains the Fisher combined p-value for each group, log-transformed if \code{log.p=TRUE}.
Each entry is named according to the group.
\item \code{representative}, a named integer scalar specifying the representative test for each group.
Each index refers to an entry of \code{p.values} and is named according to its group.
\item \code{influential}, a logical vector of length equal to \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value for its group.
}
}
\description{
Combine p-values from grouped tests with Fisher's method.
Groups are defined according to unique levels of a grouping factor.
}
\details{
The joint null hypothesis for each group is that all of the individual null hypotheses are true.
Fisher's method combines information from all individual nulls to determine if the joint null should be rejected.
Compared to Stouffer's and Pearson's methods, Fisher's method provides more sensitivity to the smallest individual p-value.
This method is only applicable to independent tests and no weights are considered.

The representative test for each group is defined as the test with the lowest p-value, as this has the greatest effect on the combined p-value. 
All tests for each group are considered to be influential as increasing any of them (e.g., to unity) would result in a larger combined p-value.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
g <- sample(10, length(p1), replace=TRUE)

# Standard application:
out <- groupedFisher(p1, g)
str(out)

# With log p-values. 
out <- groupedFisher(log(p1), g, log.p=TRUE)
str(out)

}
\references{
Fisher RA (1925).
\emph{Statistical Methods for Research Workers}.
Oliver and Boyd (Edinburgh).
}
\seealso{
\code{\link{parallelFisher}}, for a version that operates on parallel vectors of p-values.

\code{\link{groupedStouffer}} and \code{\link{groupedPearson}}, for different approaches to testing a joint null of independent hypotheses.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metapod-package.R
\docType{package}
\name{metapod-package}
\alias{metapod}
\alias{metapod-package}
\title{metapod: Meta-Analyses on P-Values of Differential Analyses}
\description{
Implements a variety of methods for combining p-values in differential analyses of genome-scale datasets. Functions can combine p-values across different tests in the same analysis (e.g., genomic windows in ChIP-seq, exons in RNA-seq) or for corresponding tests across separate analyses (e.g., replicated comparisons, effect of different treatment conditions). Support is provided for handling log-transformed input p-values, missing values and weighting where appropriate.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/LTLA/metapod}
  \item Report bugs at \url{https://github.com/LTLA/metapod/issues}
}

}
\author{
\strong{Maintainer}: Aaron Lun \email{infinite.monkeys.with.keyboards@gmail.com}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combineParallelPValues.R
\name{combineParallelPValues}
\alias{combineParallelPValues}
\title{Combine parallel p-values}
\usage{
combineParallelPValues(
  p.values,
  method = c("simes", "holm-min", "berger", "fisher", "pearson", "wilkinson",
    "stouffer"),
  weights = NULL,
  log.p = FALSE,
  min.n = 1,
  min.prop = 0.5
)
}
\arguments{
\item{p.values}{A list of numeric vectors of the same length, containing the p-values to be combined.}

\item{method}{String specifying the method to use to combine p-values.}

\item{weights}{A numeric vector of positive weights, with one value per vector in \code{...}.
Each weight is applied to all entries of itscorresponding vector, i.e., all p-values in that vector receive the same weight.

Alternatively, a list of numeric vectors of weights with the same structure as \code{p.values}.
Each p-value is then assigned the weight in the corresponding entry of \code{weights}.

Alternatively \code{NULL}, in which case all p-values are assigned equal weight.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}

\item{min.n}{Integer scalar specifying the minimum number of individual nulls to reject when testing the joint null.}

\item{min.prop}{Numeric scalar in [0, 1], specifying the minimum proportion of individual nulls to reject when testing the joint null.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
This contains the Simes p-value for each group, log-transformed if \code{log.p=TRUE}.
\item \code{representative}, an integer scalar specifying the representative test in each group.
Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
\item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
}
}
\description{
Combine p-values from parallel hypothesis tests using a variety of meta-analysis methods.
Each group of p-values is defined from the corresponding entries across all vectors.
The function processes all vectors \dQuote{in parallel} - hence the name.
}
\details{
\code{min.prop} and \code{min.n} only have an effect for \code{method="wilkinson"} and \code{"holm-min"}.

\code{weights} only has an effect for \code{method="simes"}, \code{"holm-min"} and \code{"stouffer"}.
}
\examples{
p1 <- runif(10000)
p2 <- runif(10000)
p3 <- runif(10000)

fish <- combineParallelPValues(list(p1, p2, p3), method="fisher")
hist(fish$p.value)

z <- combineParallelPValues(list(p1, p2, p3), method="stouffer", weights=1:3)
hist(z$p.value)

simes <- combineParallelPValues(list(p1, p2, p3), method="simes")
hist(simes$p.value)

berger <- combineParallelPValues(list(p1, p2, p3), method="berger")
hist(berger$p.value)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parallelHolmMin.R
\name{parallelHolmMin}
\alias{parallelHolmMin}
\title{Combine parallel p-values with the minimum Holm approach}
\usage{
parallelHolmMin(
  p.values,
  weights = NULL,
  log.p = FALSE,
  min.n = 1,
  min.prop = 0.5
)
}
\arguments{
\item{p.values}{A list of numeric vectors of the same length, containing the p-values to be combined.}

\item{weights}{A numeric vector of positive weights, with one value per vector in \code{...}.
Each weight is applied to all entries of itscorresponding vector, i.e., all p-values in that vector receive the same weight.

Alternatively, a list of numeric vectors of weights with the same structure as \code{p.values}.
Each p-value is then assigned the weight in the corresponding entry of \code{weights}.

Alternatively \code{NULL}, in which case all p-values are assigned equal weight.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}

\item{min.n}{Integer scalar specifying the minimum number of individual nulls to reject when testing the joint null.}

\item{min.prop}{Numeric scalar in [0, 1], specifying the minimum proportion of individual nulls to reject when testing the joint null.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
This contains the combined p-value for each group, log-transformed if \code{log.p=TRUE}.
\item \code{representative}, an integer scalar specifying the representative test in each group.
Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
\item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final per-group p-value.
}
}
\description{
Combine p-values from parallel tests with the minimum Holm approach.
Each group of p-values is defined from the corresponding entries across all vectors.
}
\details{
Here, the joint null hypothesis for each group is that fewer than \eqn{N} individual null hypotheses are false.
The joint null is only rejected if \eqn{N} or more individual nulls are rejected; hence the \dQuote{minimum} in the function name.

\eqn{N} is defined as the larger of \code{min.n} and the product of \code{min.prop} with the number of tests in the group (rounded up).
This allows users to scale rejection of the joint null with the size of the group, while avoiding a too-low \eqn{N} when the group is small.
Note that \eqn{N} is always capped at the total size of the group.

To compute the combined p-value, we apply the Holm-Bonferroni correction to all p-values in the set and take the \eqn{N}-th smallest value.
This effectively recapitulates the step-down procedure where we reject individual nulls until we reach the \eqn{N}-th test.
This method works correctly in the presence of dependencies between p-values.

If non-equal weights are provided, they are used to effectively downscale the p-values. 
This aims to redistribute the error rate across the individual tests,
i.e., tests with lower weights are given fewer opportunities to drive acceptance of the joint null.

The representative test for each group is defined as that with the \eqn{N}-th smallest p-value, as this is directly used as the combined p-value.
The influential tests for each group are defined as those with p-values no greater than the representative test's p-value.
This is based on the fact that increasing them (e.g., by setting them to unity) would result in a larger combined p-value.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
p2 <- runif(100)
p3 <- rbeta(100, 0.5, 1)

# Standard application:
out <- parallelHolmMin(list(p1, p2, p3))
str(out)

# With vector-level weights:
out <- parallelHolmMin(list(p1, p2, p3), weights=c(10, 20, 30))
str(out)

# With log p-values. 
out <- parallelHolmMin(list(log(p1), log(p2), log(p3)), log.p=TRUE)
str(out)

}
\references{
Holm S (1979).
A simple sequentially rejective multiple test procedure.
\emph{Scand. J. Stat.} 6, 65-70.
}
\seealso{
\code{\link{groupedHolmMin}}, for a version that combines p-values based on a grouping factor.

\code{\link{parallelWilkinson}}, for a more relaxed version of this test when hypotheses are independent.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parallelStouffer.R
\name{parallelStouffer}
\alias{parallelStouffer}
\title{Combine parallel p-values with Stouffer's Z-score}
\usage{
parallelStouffer(p.values, weights = NULL, log.p = FALSE)
}
\arguments{
\item{p.values}{A list of numeric vectors of the same length, containing the p-values to be combined.}

\item{weights}{A numeric vector of positive weights, with one value per vector in \code{...}.
Each weight is applied to all entries of itscorresponding vector, i.e., all p-values in that vector receive the same weight.

Alternatively, a list of numeric vectors of weights with the same structure as \code{p.values}.
Each p-value is then assigned the weight in the corresponding entry of \code{weights}.

Alternatively \code{NULL}, in which case all p-values are assigned equal weight.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
This contains the combined Stouffer p-value for each group, log-transformed if \code{log.p=TRUE}.
\item \code{representative}, an integer scalar specifying the representative test in each group.
Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
\item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
}
}
\description{
Combine p-values from parallel tests with Stouffer's Z-score method.
Each group of p-values is defined from the corresponding entries across all vectors.
}
\details{
The joint null hypothesis for each group is that all of the individual null hypotheses are true.
Stouffer's method combines information from all individual nulls to determine if the joint null should be rejected.
This serves as a compromise between Fisher's method (sensitive to the smallest p-value) and Pearson's method (sensitive to the largest p-value).

Stouffer's method is only applicable for independent tests.
Weights are supported by scaling the contribution of each individual null to the summed Z-score.
In this manner, more highly weighted tests will have a greater effect on the final combined p-value.

The representative test for each group is defined as the test with the most negative weighted Z-score, 
as this has the greatest effect on the combined p-value when the joint null is rejected. 
All tests for each group are considered to be influential as increasing any of them (e.g., to unity) would result in a larger combined p-value.

When a group contains both zero and unity p-values, we compare the sum of weights for all zero p-values and all unity p-values.
If the former is larger, the combined p-value is set to zero; if the latter, to unity.
If they are equal, we pretend that the two sets of p-values \dQuote{cancel out} and contribute nothing to the summed Z-score.
This is not entirely rigorous but provides reasonable output in the presence of such boundary values.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
p2 <- runif(100)
p3 <- rbeta(100, 0.5, 1)

# Standard application:
out <- parallelStouffer(list(p1, p2, p3))
str(out)

# With weights:
out <- parallelStouffer(list(p1, p2, p3), weights=5:7)
str(out)

# With log p-values. 
out <- parallelStouffer(list(log(p1), log(p2), log(p3)), log.p=TRUE)
str(out)

}
\references{
Stouffer SA et al. (1949).
\emph{The American Soldier, Vol. 1 - Adjustment during Army Life}.
Princeton University Press (Princeton).

Whitlock MC (2005).
Combining probability from independent tests: the weighted Z-method is superior to Fisher's approach.
\emph{J. Evol. Biol.} 18, 5:1368-73.
}
\seealso{
\code{\link{groupedStouffer}}, for a version that combines p-values based on a grouping factor.

\code{\link{parallelFisher}} and \code{\link{parallelPearson}}, for different approaches to testing a joint null of independent hypotheses.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parallelFisher.R
\name{parallelFisher}
\alias{parallelFisher}
\title{Combine parallel p-values with Fisher's method}
\usage{
parallelFisher(p.values, log.p = FALSE)
}
\arguments{
\item{p.values}{A list of numeric vectors of the same length, containing the p-values to be combined.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a numeric vector of length equal to the length of each vector in \code{p.values}.
This contains the combined Fisher p-value for each group, log-transformed if \code{log.p=TRUE}.
\item \code{representative}, an integer scalar specifying the representative test in each group.
Specifically, this refers to the index of the \emph{vector} of \code{p.values} containing the representative test.
\item \code{influential}, a list of logical vectors mirroring the structure of \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value.
}
}
\description{
Combine p-values from parallel tests with Fisher's method.
Each group of p-values is defined from the corresponding entries across all vectors.
}
\details{
The joint null hypothesis for each group is that all of the individual null hypotheses are true.
Fisher's method combines information from all individual nulls to determine if the joint null should be rejected.
Compared to Stouffer's and Pearson's methods, Fisher's method provides more sensitivity to the smallest individual p-value.
This method is only applicable to independent tests and no weights are considered.

The representative test for each group is defined as the test with the lowest p-value, as this has the greatest effect on the combined p-value. 
All tests for each group are considered to be influential as increasing any of them (e.g., to unity) would result in a larger combined p-value.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
p2 <- runif(100)
p3 <- rbeta(100, 0.5, 1)

# Standard application:
out <- parallelFisher(list(p1, p2, p3))
str(out)

# With log p-values. 
out <- parallelFisher(list(log(p1), log(p2), log(p3)), log.p=TRUE)
str(out)

}
\references{
Fisher RA (1925).
\emph{Statistical Methods for Research Workers}.
Oliver and Boyd (Edinburgh).
}
\seealso{
\code{\link{groupedFisher}}, for a version that combines p-values based on a grouping factor.

\code{\link{parallelStouffer}} and \code{\link{parallelPearson}}, for different approaches to testing a joint null of independent hypotheses.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/countParallelDirection.R
\name{countParallelDirection}
\alias{countParallelDirection}
\title{Count directions of parallel tests}
\usage{
countParallelDirection(
  p.values,
  effects,
  p.threshold = 0.05,
  effect.threshold = 0,
  method = c("BH", "holm"),
  log.p = FALSE
)
}
\arguments{
\item{p.values}{A list of numeric vectors of the same length, containing the p-values to be combined.}

\item{effects}{A list of numeric vectors of same structure as \code{p.values}, containing the effect sizes for each set of tests.}

\item{p.threshold}{Numeric scalar defining the adjusted p-value threshold at which test is significant.}

\item{effect.threshold}{Numeric scalar defining the threshold at which an effect is \dQuote{"up"} or \dQuote{"down"}.}

\item{method}{String specifying how the multiple testing correction within each group is to be performed.}

\item{log.p}{Logical scalar indicating whether the \code{p.values} are log-transformed.}
}
\value{
A list with the \code{"up"} and \code{"down"} entries.
Both are integer vectors of length equal to the number of groups,
containing the number of significant tests changing each each direction in each group.
}
\description{
Count the number of parallel tests that are significant and changing in each direction.
Each group of tests is defined as corresponding entries across vectors.
}
\details{
We apply a multiple testing correction within each group and define all significant tests as those with adjusted p-values below \code{p.threshold}.
We then count the number of tests with effects greater than \code{effect.threshold} (i.e., going up) or less than the threshold (i.e., going down).
This allows us to quantify the direction of change across the group into two counts.

The output of this function is simpler to interpret than the \code{summarize*Direction} functions.
However, \code{p.threshold} has no clear relationship to the significance threshold applied to the combined p-values.
Groups with many low p-values will have milder multiplicity corrections, resulting in more non-zero counts for both the \code{up} and \code{down} tests;
this often complicates matters by introducing mixed directions of effect, even when the most significant changes in the group are in one direction. 

Note that, if \code{log.p=TRUE}, the function will automatically handle the log-transformation of \code{p.threshold}.
}
\examples{
p1 <- rbeta(100, 0.5, 1)
eff1 <- rnorm(100)
p2 <- rbeta(100, 0.5, 1)
eff2 <- rnorm(100)

(dirs <- countParallelDirection(list(p1, p2), list(eff1, eff2)))

}
\seealso{
\code{\link{summarizeParallelDirection}}, for another way to summarize the overall direction into a single string.

\code{\link{countGroupedDirection}}, for the equivalent function based on a grouping factor.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/groupedStouffer.R
\name{groupedStouffer}
\alias{groupedStouffer}
\title{Combine grouped p-values with Stouffer's Z-score method}
\usage{
groupedStouffer(p.values, grouping, weights = NULL, log.p = FALSE)
}
\arguments{
\item{p.values}{A numeric vector containing p-values for individual tests.}

\item{grouping}{A vector or factor of length equal to \code{p.values}, specifying the group to which each test is assigned.

Alternatively, an \link{rle} object where each run corresponds to a group and specifies the entries of \code{p.values} belonging to that group.
This assumes that \code{p.values} is ordered such that all entries in the same group are adjacent to each other.}

\item{weights}{A numeric vector of length equal to \code{p.values}, containing a positive weight for each test.
Alternatively \code{NULL}, in which case equal weights are assigned to all tests.}

\item{log.p}{Logical scalar indicating whether the p-values in \code{p.values} are log-transformed.}
}
\value{
A list containing:
\itemize{
\item \code{p.value}, a named numeric vector of length equal to the number of unique levels in \code{grouping}.
This contains the combined p-value for each group, log-transformed if \code{log.p=TRUE}.
Each entry is named according to the group.
\item \code{representative}, a named integer scalar specifying the representative test for each group.
Each entry is named according to the group.
\item \code{influential}, a logical vector of length equal to \code{p.values}.
Entries are \code{TRUE} for any p-value that is deemed \dQuote{influential} to the final combined p-value for its group.
}
}
\description{
Combine p-values from grouped tests with Stouffer's Z-score method.
Groups are defined according to unique levels of a grouping factor.
}
\details{
The joint null hypothesis for each group is that all of the individual null hypotheses are true.
Stouffer's method combines information from all individual nulls to determine if the joint null should be rejected.
This serves as a compromise between Fisher's method (sensitive to the smallest p-value) and Pearson's method (sensitive to the largest p-value).

Stouffer's method is only applicable for independent tests.
Weights are supported by scaling the contribution of each individual null to the summed Z-score.
In this manner, more highly weighted tests will have a greater effect on the final combined p-value.

The representative test for each group is defined as the test with the most negative weighted Z-score, 
as this has the greatest effect on the combined p-value when the joint null is rejected. 
All tests for each group are considered to be influential as increasing any of them (e.g., to unity) would result in a larger combined p-value.

When a group contains both zero and unity p-values, we compare the sum of weights for all zero p-values and all unity p-values.
If the former is larger, the combined p-value is set to zero; if the latter, to unity.
If they are equal, we pretend that the two sets of p-values \dQuote{cancel out} and contribute nothing to the summed Z-score.
This is not entirely rigorous but provides reasonable output in the presence of such boundary values.
}
\examples{
p1 <- rbeta(100, 0.8, 1)
g <- sample(10, length(p1), replace=TRUE)

# Standard application:
out <- groupedStouffer(p1, g)
str(out)

# With weights:
out <- groupedStouffer(p1, g, weights=rexp(length(p1)))
str(out)

# With log p-values. 
out <- groupedStouffer(log(p1), g, log.p=TRUE)
str(out)

}
\references{
Stouffer SA et al. (1949).
\emph{The American Soldier, Vol. 1 - Adjustment during Army Life}.
Princeton University Press (Princeton).

Whitlock MC (2005).
Combining probability from independent tests: the weighted Z-method is superior to Fisher's approach.
\emph{J. Evol. Biol.} 18, 5:1368-73.
}
\seealso{
\code{\link{parallelStouffer}}, for a version that operates on parallel vectors of p-values.

\code{\link{groupedFisher}} and \code{\link{groupedPearson}}, for different approaches to testing a joint null of independent hypotheses.
}
\author{
Aaron Lun
}
